/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Brush } from "igniteui-angular-core";
import { XYChart } from "./XYChart";
import { IndicatorPane } from "./IndicatorPane";
import { Base, BaseError, EventArgs, runOn, delegateRemove, delegateCombine, fromEnum, typeCast, EnumUtil, Number_$type, String_$type, enumGetBox, markType, TypeRegistrar, fromEn } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { DataSeriesType_$type } from "igniteui-angular-core";
import { IDataSeriesAdapterRule_$type } from "igniteui-angular-core";
import { SimpleFinancialPriceSeriesRule } from "igniteui-angular-core";
import { SubCollectionsRule } from "igniteui-angular-core";
import { XamDataChart } from "./XamDataChart";
import { FinancialChartVolumeType_$type } from "./FinancialChartVolumeType";
import { FinancialChartXAxisMode_$type } from "./FinancialChartXAxisMode";
import { FinancialChartYAxisMode_$type } from "./FinancialChartYAxisMode";
import { FinancialChartType_$type } from "./FinancialChartType";
import { NumericYAxis } from "./NumericYAxis";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { FinancialChartZoomSliderType_$type } from "./FinancialChartZoomSliderType";
import { BrushCollection } from "igniteui-angular-core";
import { FinancialChartRangeSelectorOptionCollection } from "./FinancialChartRangeSelectorOptionCollection";
import { ObservableCollection$1 } from "igniteui-angular-core";
import { TemplatedHtmlControl } from "./TemplatedHtmlControl";
import { FinancialChartContext } from "./FinancialChartContext";
import { FinancialChartToolbarContext } from "./FinancialChartToolbarContext";
import { FinancialChartViewModel } from "./FinancialChartViewModel";
import { FinancialChartToolbarViewModel } from "./FinancialChartToolbarViewModel";
import { AxisDefaults } from "./AxisDefaults";
import { Defaults } from "./Defaults";
import { BrushUtil } from "igniteui-angular-core";
import { Series } from "./Series";
import { Rect } from "igniteui-angular-core";
import { Axis } from "./Axis";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { MarkerSeries } from "./MarkerSeries";
import { IZoomableCategoryAxis_$type } from "./IZoomableCategoryAxis";
import { SyncSettings } from "./SyncSettings";
import { SyncManager } from "./SyncManager";
import { FinancialOverlayType_$type } from "./FinancialOverlayType";
import { ArrayExtension } from "igniteui-angular-core";
import { FinancialIndicatorType_$type } from "./FinancialIndicatorType";
import { IndicatorDisplayType_$type } from "./IndicatorDisplayType";
import { ITimeRangeSelectorAxis_$type } from "./ITimeRangeSelectorAxis";
import { FinancialChartVisualData } from "./FinancialChartVisualData";
import { FinancialChartCustomIndicatorArgs } from "./FinancialChartCustomIndicatorArgs";
import { ScalerParams } from "./ScalerParams";
import { stringReplace, stringJoin, stringIsNullOrEmpty } from "igniteui-angular-core";
import { timeSpanFromDays } from "igniteui-angular-core";
import { dateMaxValue, dateMinValue } from "igniteui-angular-core";
import { isNaN_, isInfinity } from "igniteui-angular-core";
import { FinancialChartTypePicker } from "./FinancialChartTypePicker";
import { FinancialChartIndicatorMenu } from "./FinancialChartIndicatorMenu";
import { TrendLineType_$type } from "igniteui-angular-core";
import { FinancialChartIndicatorMenuContext } from "./FinancialChartIndicatorMenuContext";
import { FinancialChartTypePickerContext } from "./FinancialChartTypePickerContext";
import { FinancialChartRangeSelectorContext } from "./FinancialChartRangeSelectorContext";
import { FinancialChartToolbarVisualData } from "./FinancialChartToolbarVisualData";
import { FinancialChartRangeSelectorViewModel } from "./FinancialChartRangeSelectorViewModel";
import { FinancialChartRangeSelectorView } from "./FinancialChartRangeSelectorView";
/**
 * @hidden
 */
export let FinancialChart = /*@__PURE__*/ (() => {
    class FinancialChart extends XYChart {
        constructor() {
            super();
            this.ajp = null;
            this.amn = null;
            this.aml = null;
            this.ami = null;
            this.amk = null;
            this.amm = null;
            this.amj = null;
            this.aiv = null;
            this.am5 = null;
            this.am6 = null;
            this.am2 = null;
            this.am7 = null;
            this.am8 = null;
            this.am3 = null;
            this.am4 = null;
            this.akd = null;
            this.aln = 40;
            this.ajj = null;
            this.ajh = null;
            this.ajl = null;
            this.ajq = null;
            this.ang = null;
            this.aj9 = null;
            this.akz = false;
            this.aky = false;
            this.ak6 = false;
            this.akl = false;
            this.amt = 10;
            this.alu = NaN;
            this.alw = NaN;
            this.alv = NaN;
            this.alx = 0;
            this.ai1 = 0;
            this.ai4 = 0;
            this.alp = 3;
            this.als = NaN;
            this.alq = NaN;
            this.alr = NaN;
            this.alt = NaN;
            this.ai6 = 0;
            this.akg = true;
            this.aix = 0;
            this.akh = false;
            this.ajb = null;
            this.ajd = null;
            this.ak8 = null;
            this.akj = true;
            this.aki = false;
            this.akk = false;
            this.aka = null;
            this.ai8 = 1;
            this.ahz = null;
            this.ah0 = null;
            this.ah1 = null;
            this.ah2 = null;
            this.ah4 = null;
            this.ah3 = null;
            this.ahy = null;
            this.ahx = null;
            this.alo = 1;
            this.alm = 1;
            this.all = 2;
            this.alk = 1;
            this.ajn = null;
            this.amp = -2147483648;
            this.alj = 2;
            this.ams = 3;
            this.amq = 10;
            this.amo = 30;
            this.amr = 9;
            this.ais = null;
            this.ait = null;
            this.aio = null;
            this.applyCustomIndicators = null;
            this.ara = null;
            this.aly = 1;
            this.akf = false;
            this.ajf = null;
            this.alg = dateMinValue();
            this.alf = dateMaxValue();
            this.ald = null;
            this.u2();
            this.ald = new ObservableCollection$1(Base.$, 0);
            if (this.xAxisBreaks != null) {
                let a = this.xAxisBreaks;
                a.collectionChanged = delegateCombine(a.collectionChanged, (a, b) => this.aqz());
            }
            this.aqk();
        }
        wi(a, b, c) {
            super.wi(a, b, c);
            switch (a) {
                case "ToolbarTemplate":
                case "RangeSelectorTemplate":
                    this.aiw = new FinancialChartToolbar(this, this.and);
                    break;
                case "Toolbar":
                    let d = b;
                    if (d != null) {
                        d.chartTypeChanged = delegateRemove(d.chartTypeChanged, runOn(this, this.ap7));
                        d.trendLineTypeChanged = delegateRemove(d.trendLineTypeChanged, runOn(this, this.aqa));
                        d.volumeTypeChanged = delegateRemove(d.volumeTypeChanged, runOn(this, this.aqb));
                        d.l(null);
                    }
                    if (this.aiw != null) {
                        this.aiw.ac = this.ai3;
                        this.aiw.ai = this.ec;
                        this.aiw.y = this.aiy;
                        this.aiw.al = this.akw;
                        if (this.amk != null) {
                            this.aiw.l(this.amk);
                        }
                        let e = this.aiw;
                        e.chartTypeChanged = delegateCombine(e.chartTypeChanged, runOn(this, this.ap7));
                        ;
                        let f = this.aiw;
                        f.trendLineTypeChanged = delegateCombine(f.trendLineTypeChanged, runOn(this, this.aqa));
                        let g = this.aiw;
                        g.volumeTypeChanged = delegateCombine(g.volumeTypeChanged, runOn(this, this.aqb));
                    }
                    break;
                case "ChartType":
                    if (this.aiw != null) {
                        this.aiw.y = this.aiy;
                    }
                    break;
                case "VolumeType":
                    if (this.aiw != null) {
                        this.aiw.ac = this.ai3;
                    }
                    break;
                case "TrendLineType":
                    if (this.aiw != null) {
                        this.aiw.ai = this.ec;
                    }
                    break;
                case "IsToolbarVisible":
                    if (this.aiw == null) {
                        break;
                    }
                    this.aiw.al = this.akw;
                    this.setGridRows();
                    break;
            }
        }
        aqb(a, b) {
            this.ai3 = this.aiw.ac;
        }
        aqa(a, b) {
            this.ec = this.aiw.ai;
        }
        ap7(a, b) {
            this.aiy = this.aiw.y;
        }
        aqk() {
            this.ajp = new IndicatorPane();
            this.ajg = TypeRegistrar.create("FinancialLegend");
        }
        provideGrid(a) {
            this.amn = a;
            this.aq5();
            this.setGridRows();
            if (this.aiw != null) {
                this.aiw.bg(a);
            }
        }
        onDocumentClick(a) {
            if (this.aiw != null) {
                this.aiw.bl(a);
            }
        }
        getContext() {
            let a = this.aiw.v();
            let b = new FinancialChartContext();
            b.vm = new FinancialChartViewModel();
            b.vm.toolbar = a;
            b.container = this.l4;
            b.toolbarContainer = this.amk;
            b.legendContainer = this.amj;
            b.indicatorsContainer = this.ami;
            b.volumeContainer = this.aml;
            b.zoomContainer = this.amm;
            return b;
        }
        provideContainer(a) {
            let b = a;
            if (b != null) {
                let c = "financialChartMainGrid";
                let d = b.createElement("div");
                d.setStyleProperty("width", "100%");
                d.setStyleProperty("height", "100%");
                if (this.aiw == null) {
                    this.aiw = new FinancialChartToolbar(this, this.and);
                }
                this.aiw.w.isIndicatorMenuVisible = this.akn && this.ako;
                this.amk = b.getSubRenderer(d);
                this.aiw.l(this.amk);
                let e = b.createElement("div");
                e.setStyleProperty("width", "100%");
                e.setStyleProperty("height", "100%");
                let f = b.createElement("div");
                f.setStyleProperty("width", "100%");
                f.setStyleProperty("height", "100%");
                this.amj = b.getSubRenderer(f);
                let g = b.createElement("div");
                g.setStyleProperty("width", "100%");
                g.setStyleProperty("height", "100%");
                this.ami = b.getSubRenderer(g);
                let h = b.createElement("div");
                h.setStyleProperty("width", "100%");
                h.setStyleProperty("height", "100%");
                this.aml = b.getSubRenderer(h);
                let i = b.createElement("div");
                i.setStyleProperty("width", "100%");
                i.setStyleProperty("height", "100%");
                this.amm = b.getSubRenderer(i);
                a = b.getSubRenderer(e);
            }
            else {
                this.amk = null;
                if (this.aiw != null) {
                    this.aiw.l(null);
                }
                if (this.ake != null) {
                    this.ake.provideContainer(null);
                    this.ake = null;
                }
                if (this.ajg != null) {
                    this.ajg.provideContainer(null);
                }
            }
            super.provideContainer(a);
            if (b != null) {
                if (this.volumeChart != null) {
                    this.volumeChart.c9.b4(this.aml);
                }
                if (this.ajp != null) {
                    this.ajp.h(this.ami);
                }
                if (this.zoomSliderChart != null) {
                    this.zoomSliderChart.c9.b4(this.amm);
                    if (a != null) {
                        this.apr();
                    }
                    else {
                        this.ake = null;
                    }
                }
                if (this.ajg != null) {
                    this.ajg.provideContainer(this.amj);
                }
                this.setGridRows();
            }
        }
        aqv(a, b, c) {
            if (a != null) {
                a.provideContainer(null);
            }
            if (b != null) {
                b.c9.b4(c);
            }
            this.setGridRows();
        }
        aq9(a, b) {
            this.aqv(a, b, this.amm);
            if (b == null) {
                return;
            }
            this.apr();
        }
        apr() {
            if (this.amm == null) {
                return;
            }
            if (this.ake != null) {
                this.ake.provideContainer(null);
            }
            this.ake = TypeRegistrar.create("ZoomSlider");
            this.ake.provideContainer(this.amm);
            let a = this.ake;
            a.windowRectChanged = delegateCombine(a.windowRectChanged, (a, b) => {
                if (this.dataChart != null) {
                    this.dataChart.w0 = new Rect(0, this.ake.windowRect.left, this.dataChart.wh.top, this.ake.windowRect.width, this.dataChart.wh.height);
                }
            });
            this.aps();
        }
        aq7(a, b) {
            this.aqv(a, b, this.aml);
        }
        setGridRows() {
            if (this.amn == null) {
                return;
            }
            let a = new Array(6);
            a[0] = (this.akw ? this.al4 : 0) + "px";
            a[1] = this.aks ? "min-content" : "0px";
            a[2] = "auto";
            a[3] = this.indicatorCharts == null || this.indicatorCharts.count == 0 ? "0px" : this.indicatorCharts.count * 150 + "px";
            a[4] = this.volumeChart == null ? "0px" : "100px";
            a[5] = this.zoomSliderChart == null ? "0px" : "100px";
            if (this.ake != null) {
                if (a[5] == "0px") {
                    this.ake.hide();
                }
                else {
                    this.ake.show();
                }
            }
            this.amn.setStyleProperty("-ms-grid-rows", stringReplace(stringJoin(" ", ...a), "auto", "1fr"));
            this.amn.setStyleProperty("grid-template-rows", stringJoin(" ", ...a));
            if (this.l4 == null) {
                return;
            }
            if (this.dataChart != null) {
                this.dataChart.notifyContainerResized();
            }
            if (this.ajp != null) {
                this.ajp.f();
            }
            if (this.volumeChart != null) {
                this.volumeChart.notifyContainerResized();
            }
            if (this.zoomSliderChart != null) {
                this.zoomSliderChart.notifyContainerResized();
            }
            if (this.ake != null) {
                this.ake.notifySizeChanged();
            }
        }
        vm() {
            super.vm();
            this.aaz = 1;
            this.agq = 0;
            this.ac4 = 0;
            this.ahk = null;
            this.ahd = AxisDefaults.axis_LineBrush;
            this.acm = AxisDefaults.axis_TickStroke;
            this.acl = AxisDefaults.categoryAxis_TickLength;
            this.ahe = AxisDefaults.axis_TickBrush;
            this.aha = null;
            this.arb = AxisDefaults.axis_MajorBrush;
            this.amh = AxisDefaults.axis_MajorStroke;
            this.finalValueAnnotationsVisible = true;
            this.crosshairsAnnotationEnabled = true;
            this.gq = false;
            this.crosshairsDisplayMode = 0;
            this.jq = Defaults.crosshairLineThickness;
            this.yy = Defaults.crosshairLineBrush;
            this.yt = Defaults.crosshairXAxisAnnotationBackground;
            this.yu = Defaults.crosshairXAxisAnnotationTextColor;
            this.ka = NaN;
            this.j2 = 40;
            this.g6 = true;
            this.he = false;
            if (this.dataChart != null) {
                let a = this.dataChart.c9.j.e();
                this.ah7 = a.d;
                this.ah8 = a.e;
                this.ah6 = a.d;
                this.arb = this.dataChart.aa5;
            }
            let b = new BrushCollection();
            b.add(((() => {
                let $ret = new Brush();
                $ret.fill = "#8BDC5C";
                return $ret;
            })()));
            b.add(((() => {
                let $ret = new Brush();
                $ret.fill = "#8961A9";
                return $ret;
            })()));
            b.add(((() => {
                let $ret = new Brush();
                $ret.fill = "#6DB1FF";
                return $ret;
            })()));
            b.add(((() => {
                let $ret = new Brush();
                $ret.fill = "#82E9D9";
                return $ret;
            })()));
            b.add(((() => {
                let $ret = new Brush();
                $ret.fill = "#EA3C63";
                return $ret;
            })()));
            b.add(((() => {
                let $ret = new Brush();
                $ret.fill = "#735656";
                return $ret;
            })()));
            b.add(((() => {
                let $ret = new Brush();
                $ret.fill = "#F8CE4F";
                return $ret;
            })()));
            b.add(((() => {
                let $ret = new Brush();
                $ret.fill = "#A8A8B7";
                return $ret;
            })()));
            b.add(((() => {
                let $ret = new Brush();
                $ret.fill = "#E051A9";
                return $ret;
            })()));
            b.add(((() => {
                let $ret = new Brush();
                $ret.fill = "#FF903B";
                return $ret;
            })()));
            let c = new BrushCollection();
            for (let d of fromEnum(b)) {
                c.add(BrushUtil.p(d, 0.3));
            }
            this.ah9 = c;
            this.aia = b;
        }
        aqr() {
            if (this.ajp != null) {
                this.ajp.b = null;
                this.ajp.b = this.indicatorCharts;
            }
            this.setGridRows();
        }
        aqs() {
            this.setGridRows();
        }
        aq1() {
            this.aqr();
        }
        apq() {
            if (this.ake == null || this.zoomSliderChart == null || this.dataChart == null || this.dataChart.series.count == 0) {
                return;
            }
            let a = this.l4.rootWrapper.width();
            let b = this.dataChart.wz.left + this.dataChart.wz.width;
            let c = this.dataChart.wz.left;
            let d = a - b;
            this.ake.startInset = c - this.ake.trackStartInset;
            this.ake.endInset = d - this.ake.trackEndInset;
            if (this.ake.endInset < 0) {
                let e = this.ake.endInset;
                this.ake.endInset = 0;
                this.dataChart.h9 += (e * -1);
            }
            if (this.ake.startInset < 0) {
                let f = this.ake.startInset;
                this.ake.startInset = 0;
                this.dataChart.h4 += (f * -1);
            }
            this.zoomSliderChart.h4 = c;
            this.zoomSliderChart.h9 = d;
            this.zoomSliderChart.hr = this.ake.barExtent;
        }
        aqh() {
            this.apq();
        }
        vj(a) {
            super.vj(a);
            if (a != null) {
                a.hq = 0;
            }
        }
        arc(a) {
            return a.wa();
        }
        arf() {
            return this.amj == null ? null : this.are(this.amj.rootWrapper);
        }
        ard(a) {
            if (a == null || a.d == null) {
                return null;
            }
            return this.are(a.d.rootWrapper);
        }
        are(a) {
            if (a == null) {
                return null;
            }
            let b = a.getOffset();
            return new Rect(0, b.left, b.top, a.width(), a.height());
        }
        alz() {
            if (this.amn == null) {
                return NaN;
            }
            let a = this.amn.getOffset();
            return this.amn.width() + (a == null ? 0 : a.left);
        }
        vv(source_, a, b) {
            super.vv(source_, a, b);
            if (this.zoomSliderChart != null) {
                this.zoomSliderChart.on(source_, a, b);
            }
        }
        vw(source_, a, b) {
            super.vw(source_, a, b);
            if (this.zoomSliderChart != null) {
                this.zoomSliderChart.oo(source_, a, b);
            }
        }
        vu(source_) {
            super.vu(source_);
            if (this.zoomSliderChart != null) {
                this.zoomSliderChart.og(source_);
            }
        }
        vy(source_, a, b, c) {
            super.vy(source_, a, b, c);
            if (this.zoomSliderChart != null) {
                this.zoomSliderChart.op(source_, a, b, c);
            }
        }
        vp(a, b) {
            super.vp(a, b);
            if (this.akt(a)) {
                a.toolTip = null;
            }
        }
        get aiw() {
            return this.aiv;
        }
        set aiw(a) {
            let b = this.aiw;
            if (a != b) {
                this.aiv = a;
                this.wd("Toolbar", b, this.aiw);
            }
        }
        get anc() {
            return this.am5;
        }
        set anc(a) {
            let b = this.anc;
            if (a != b) {
                this.am5 = a;
                this.wd("RangeSelectorTemplate", b, this.anc);
            }
        }
        get and() {
            return this.am6;
        }
        set and(a) {
            let b = this.and;
            if (a != b) {
                this.am6 = a;
                this.wd("ToolbarTemplate", b, this.and);
            }
        }
        get am9() {
            return this.am2;
        }
        set am9(a) {
            let b = this.am9;
            if (a != b) {
                this.am2 = a;
                this.wd("ChartTypePickerTemplate", b, this.am9);
            }
        }
        get ane() {
            return this.am7;
        }
        set ane(a) {
            let b = this.ane;
            if (a != b) {
                this.am7 = a;
                this.wd("TrendLineTypePickerTemplate", b, this.ane);
            }
        }
        get anf() {
            return this.am8;
        }
        set anf(a) {
            let b = this.anf;
            if (a != b) {
                this.am8 = a;
                this.wd("VolumeTypePickerTemplate", b, this.anf);
            }
        }
        get ana() {
            return this.am3;
        }
        set ana(a) {
            let b = this.ana;
            if (a != b) {
                this.am3 = a;
                this.wd("IndicatorMenuTemplate", b, this.ana);
            }
        }
        get anb() {
            return this.am4;
        }
        set anb(a) {
            let b = this.anb;
            if (a != b) {
                this.am4 = a;
                this.wd("OverlayPickerTemplate", b, this.anb);
            }
        }
        get ake() {
            return this.akd;
        }
        set ake(a) {
            let b = this.ake;
            if (a != b) {
                this.akd = a;
                this.wd("ZoomSlider", b, this.ake);
            }
        }
        get_j2() {
            return super.get_j2();
        }
        set_j2(a) {
            super.set_j2(a);
        }
        get_g6() {
            return super.get_g6();
        }
        set_g6(a) {
            super.set_g6(a);
        }
        get al4() {
            return this.aln;
        }
        set al4(a) {
            let b = this.al4;
            if (a != b) {
                this.aln = a;
                this.wd("ToolbarHeight", b, this.al4);
            }
        }
        aao() {
            return this.xAxis;
        }
        aap() {
            return this.yAxis;
        }
        onAttachedToUI() {
            super.onAttachedToUI();
            if (this.ake != null) {
                this.ake.onAttachedToUI();
            }
        }
        onDetachedFromUI() {
            super.onDetachedFromUI();
            if (this.ake != null) {
                this.ake.onDetachedFromUI();
            }
        }
        be(a) {
            return 20;
        }
        get_h2() {
            return ((() => {
                let $ret = new List$1(DataSeriesType_$type, 0);
                $ret.add(20);
                return $ret;
            })());
        }
        get h2() {
            return this.get_h2();
        }
        get_h1() {
            return ((() => {
                let $ret = new List$1(IDataSeriesAdapterRule_$type, 0);
                $ret.add(new SimpleFinancialPriceSeriesRule());
                $ret.add(new SubCollectionsRule());
                return $ret;
            })());
        }
        get h1() {
            return this.get_h1();
        }
        aii(a) {
            return this.aij(a);
        }
        ajw(a) {
            return this.ajx(a);
        }
        aih(a) {
            let b = this.aii(0);
            b.name = a;
            return b;
        }
        ux() {
            this.xAxis = this.aih("xAxis");
            this.yAxis = this.ajw(0);
            this.yAxis.name = "yAxis";
            this.volumeAxis = this.ajw(0);
            this.volumeAxis.name = "volumeAxis";
            this.volumeXAxis = this.aih("volumeXAxis");
            this.ala = new List$1(NumericYAxis.$, 0);
            this.alc = new List$1(CategoryAxisBase.$, 0);
            this.indicatorAxis = this.ajw(0);
            this.indicatorAxis.name = "indicatorAxis";
            this.indicatorXAxis = this.aih("indicatorXAxis_0");
            this.ala.add(this.indicatorAxis);
            this.alc.add(this.indicatorXAxis);
            if (this.xAxis.az == null) {
                this.xAxis.az = new AxisLabelSettings();
            }
            if (this.yAxis.az == null) {
                this.yAxis.az = new AxisLabelSettings();
            }
            if (this.volumeAxis.az == null) {
                this.volumeAxis.az = new AxisLabelSettings();
            }
            if (this.volumeXAxis.az == null) {
                this.volumeAxis.az = new AxisLabelSettings();
            }
            if (this.indicatorAxis.az == null) {
                this.indicatorAxis.az = new AxisLabelSettings();
            }
            if (this.indicatorXAxis.az == null) {
                this.indicatorXAxis.az = new AxisLabelSettings();
            }
            this.zoomSliderAxis = this.ajw(0);
            this.zoomSliderAxis.name = "zoomSliderAxis";
            this.zoomSliderXAxis = this.aih("zoomSliderXAxis");
            if (this.zoomSliderAxis.az == null) {
                this.zoomSliderAxis.az = new AxisLabelSettings();
            }
            if (this.zoomSliderXAxis.az == null) {
                this.zoomSliderXAxis.az = new AxisLabelSettings();
            }
        }
        ur(a, b) {
            let c = typeCast(MarkerSeries.$, a);
            if (c != null) {
                c.xf = this.c2(a, b);
            }
        }
        c1(a) {
            if (a != null) {
                return 1;
            }
            return super.c1(a);
        }
        w8(a) {
            if (a.suggestedSecondaryAxis == 2) {
                this.yAxis.lo = true;
                this.yAxis.mm = 10;
            }
        }
        xb() {
            this.yAxis.lo = this.ak3;
            this.yAxis.mm = this.am1;
        }
        ai0(a) {
            let b;
            if (this.aiy == 0) {
                if (a == null || a.index > 0 || stringIsNullOrEmpty(a.getMemberPathFor(12))) {
                    b = 4;
                }
                else {
                    b = 2;
                }
            }
            else {
                b = this.aiy;
            }
            b = this.aiz(b);
            return b;
        }
        aiz(a) {
            if ((a == 1 || a == 2)) {
                if (TypeRegistrar.isRegistered("FinancialPriceSeries")) {
                    return a;
                }
                a = 4;
            }
            if (a == 4) {
                if (TypeRegistrar.isRegistered("LineSeries")) {
                    return a;
                }
                a = 3;
            }
            if (a == 3) {
                if (TypeRegistrar.isRegistered("ColumnSeries")) {
                    return a;
                }
            }
            return a;
        }
        ai9(a) {
            if ((a == 2 || a == 3)) {
                if (TypeRegistrar.isRegistered("FinancialPriceSeries")) {
                    return a;
                }
                a = 5;
            }
            if (a == 5) {
                if (TypeRegistrar.isRegistered("LineSeries")) {
                    return a;
                }
                a = 6;
            }
            if (a == 6) {
                if (TypeRegistrar.isRegistered("AreaSeries")) {
                    return a;
                }
                a = 4;
            }
            if (a == 4) {
                if (TypeRegistrar.isRegistered("ColumnSeries")) {
                    return a;
                }
            }
            return a;
        }
        ai2(a) {
            if (a == 2) {
                if (TypeRegistrar.isRegistered("LineSeries")) {
                    return a;
                }
                a = 3;
            }
            if (a == 3) {
                if (TypeRegistrar.isRegistered("AreaSeries")) {
                    return a;
                }
                a = 1;
            }
            if (a == 1) {
                if (TypeRegistrar.isRegistered("ColumnSeries")) {
                    return a;
                }
            }
            return a;
        }
        ano(a) {
            let b = a.getMemberPathFor(14);
            if (stringIsNullOrEmpty(b)) {
                b = a.getMemberPathFor(11);
            }
            return b;
        }
        aij(axisType_) {
            if ((this.externalObject)) {
                return (this.externalObject.createXAxis(axisType_).i);
            }
            else {
                let a;
                switch (axisType_) {
                    case 0:
                        if (TypeRegistrar.isRegistered("OrdinalTimeXAxis")) {
                            a = TypeRegistrar.create("OrdinalTimeXAxis");
                        }
                        else if (TypeRegistrar.isRegistered("TimeXAxis")) {
                            a = TypeRegistrar.create("TimeXAxis");
                        }
                        else {
                            throw new BaseError(1, "no valid axes loaded");
                        }
                        return a;
                    case 1:
                        if (TypeRegistrar.isRegistered("TimeXAxis")) {
                            a = TypeRegistrar.create("TimeXAxis");
                        }
                        else if (TypeRegistrar.isRegistered("OrdinalTimeXAxis")) {
                            a = TypeRegistrar.create("OrdinalTimeXAxis");
                        }
                        else {
                            throw new BaseError(1, "no valid axes loaded");
                        }
                        return a;
                }
                return null;
            }
        }
        ajx(axisType_) {
            if ((this.externalObject)) {
                return (this.externalObject.createYAxis(axisType_).i);
            }
            else {
                let a;
                switch (axisType_) {
                    case 0:
                        if (TypeRegistrar.isRegistered("NumericYAxis")) {
                            a = TypeRegistrar.create("NumericYAxis");
                        }
                        else if (TypeRegistrar.isRegistered("PercentChangeYAxis")) {
                            a = TypeRegistrar.create("PercentChangeYAxis");
                        }
                        else {
                            throw new BaseError(1, "no valid axes loaded");
                        }
                        return a;
                    case 1:
                        if (TypeRegistrar.isRegistered("PercentChangeYAxis")) {
                            a = TypeRegistrar.create("PercentChangeYAxis");
                        }
                        else if (TypeRegistrar.isRegistered("NumericYAxis")) {
                            a = TypeRegistrar.create("NumericYAxis");
                        }
                        else {
                            throw new BaseError(1, "no valid axes loaded");
                        }
                        return a;
                }
                return null;
            }
        }
        aj3() {
            return this.df(1);
        }
        aj4() {
            return this.df(0);
        }
        aj2() {
            return this.df(2);
        }
        aj5() {
            return this.df(20);
        }
        get akm() {
            return (TypeRegistrar.isRegistered("HorizontalAnchoredCategorySeriesProxy"));
        }
        get ajk() {
            if (TypeRegistrar.isRegistered("HorizontalAnchoredCategorySeriesProxy")) {
                return TypeRegistrar.create("HorizontalAnchoredCategorySeriesProxy");
            }
            else {
                throw new BaseError(1, "horizontal series module is not loaded, but is required.");
            }
        }
        get akp() {
            return (TypeRegistrar.isRegistered("FinancialPriceSeriesProxy"));
        }
        get aji() {
            if (TypeRegistrar.isRegistered("FinancialPriceSeriesProxy")) {
                return TypeRegistrar.create("FinancialPriceSeriesProxy");
            }
            else {
                throw new BaseError(1, "financial series module is not loaded, but is required.");
            }
        }
        get akn() {
            return (TypeRegistrar.isRegistered("IndicatorProxy"));
        }
        get ajm() {
            if (TypeRegistrar.isRegistered("IndicatorProxy")) {
                return TypeRegistrar.create("IndicatorProxy");
            }
            else {
                throw new BaseError(1, "financial series module is not loaded, but is required.");
            }
        }
        get ako() {
            return (TypeRegistrar.isRegistered("OverlayProxy"));
        }
        get ajr() {
            if (TypeRegistrar.isRegistered("OverlayProxy")) {
                return TypeRegistrar.create("OverlayProxy");
            }
            else {
                throw new BaseError(1, "overlay series module is not loaded, but is required.");
            }
        }
        dc(a, b) {
            let c = this.ano(a);
            switch (this.ai0(a)) {
                case 3:
                    let d = this.aj3();
                    this.ajk.setValueMemberPath(d, c);
                    this.ajk.setXAxis(d, this.xAxis);
                    this.ajk.setYAxis(d, this.yAxis);
                    this.ajk.setCategoryMode(d, 1);
                    return d;
                case 4:
                    let e = this.aj4();
                    this.ajk.setValueMemberPath(e, c);
                    this.ajk.setXAxis(e, this.xAxis);
                    this.ajk.setYAxis(e, this.yAxis);
                    this.ajk.setCategoryMode(e, 1);
                    return e;
                default:
                case 1:
                case 2:
                    let f = this.aj5();
                    this.aji.setOpenMemberPath(f, a.getMemberPathFor(11));
                    this.aji.setHighMemberPath(f, a.getMemberPathFor(12));
                    this.aji.setLowMemberPath(f, a.getMemberPathFor(13));
                    this.aji.setCloseMemberPath(f, a.getMemberPathFor(14));
                    this.aji.setVolumeMemberPath(f, a.getMemberPathFor(15));
                    this.aji.setXAxis(f, this.xAxis);
                    this.aji.setYAxis(f, this.yAxis);
                    this.aji.setDisplayType(f, this.aiy == 1 ? 1 : 0);
                    this.aji.setCategoryMode(f, 1);
                    return f;
            }
        }
        xa() {
            super.xa();
            this.aqf(this.xAxis);
            this.aq3(false);
            if (this.ai3 != 0 && this.volumeChart != null) {
                this.aqm();
            }
            this.aqf(this.volumeXAxis);
            this.aqf(this.indicatorXAxis);
            this.aq0();
            this.aq2();
            if (this.aja != 0) {
                this.aqn();
                this.aqf(this.zoomSliderXAxis);
            }
        }
        agc(a, b) {
            super.agc(a, b);
            a(this.volumeXAxis);
            if (this.alc != null) {
                for (let c of fromEnum(this.alc)) {
                    a(c);
                }
            }
            let d = true;
            switch (b) {
                case "XAxisMajorStroke":
                case "XAxisMajorStrokeThickness":
                    d = false;
                    break;
            }
            if (d) {
                a(this.zoomSliderXAxis);
            }
        }
        agh(a, b) {
            super.agh(a, b);
            if (b) {
                a(this.volumeAxis);
                if (this.ala != null) {
                    for (let c of fromEnum(this.ala)) {
                        a(c);
                    }
                }
                a(this.zoomSliderAxis);
            }
        }
        aqj(a) {
            let b = typeCast(IZoomableCategoryAxis_$type, this.xAxis);
            if (b != null) {
                a(b);
            }
        }
        agf(a) {
            super.agf(a);
            this.af6(this.volumeXAxis, a);
            this.af6(this.indicatorXAxis, a);
            this.af6(this.zoomSliderXAxis, a);
        }
        agk(a) {
            super.agk(a);
            this.af6(this.volumeAxis, a);
            this.af6(this.indicatorAxis, a);
            this.af6(this.zoomSliderAxis, a);
        }
        agi(a) {
            super.agi(a);
            this.af5(this.volumeAxis, a);
            this.af5(this.indicatorAxis, a);
            this.af5(this.zoomSliderAxis, a);
        }
        agd(a) {
            super.agd(a);
            this.af5(this.volumeXAxis, a);
            this.af5(this.indicatorXAxis, a);
            this.af5(this.zoomSliderXAxis, a);
        }
        vi(a) {
            super.vi(a);
            if (a == null) {
                return;
            }
            if (a == this.zoomSliderChart) {
                a.xv = a.xy = false;
                a.legend = null;
                if (this.dataChart != null) {
                    a.ag = this.dataChart.ag;
                    a.aj = this.dataChart.aj;
                }
            }
            else {
                SyncManager.d(a, ((() => {
                    let $ret = new SyncSettings();
                    $ret.syncChannel = this.aoj();
                    $ret.synchronizeHorizontally = true;
                    $ret.synchronizeVertically = false;
                    return $ret;
                })()));
                SyncManager.c(a);
            }
            a.cw = 2;
        }
        aoj() {
            if (this.ang == null) {
                FinancialChart.am0++;
                this.ang = FinancialChart.am0.toString();
            }
            return this.ang;
        }
        ap1(a, b) {
            this.apn();
            this.aqh();
        }
        apn() {
            if (this.yAxis.b8()) {
                return;
            }
            let a = this.yAxis.aw.bd;
            if (this.ai3 != 0) {
                a = Math.max(a, this.volumeAxis.aw.bd);
            }
            for (let b of fromEnum(this.ala)) {
                a = Math.max(a, b.aw.bd);
            }
            this.apo(a);
        }
        apo(a) {
            if (this.yAxis.b8()) {
                return;
            }
            this.yAxis.eu = this.volumeAxis.eu = a;
            for (let b of fromEnum(this.ala)) {
                b.eu = a;
            }
            this.zoomSliderAxis.eu = this.yAxis.eu;
        }
        apt(a) {
            if (this.indicatorCharts == null) {
                return;
            }
            for (let b = 0; b < this.indicatorCharts.count; b++) {
                let c = this.indicatorCharts._inner[b];
                for (let d = 0; d < c.series.count; d++) {
                    let e = c.series._inner[d];
                    if (!(this.akr(e))) {
                        continue;
                    }
                    a(c.series._inner[d], b);
                }
            }
        }
        apw(a) {
            if (this.volumeChart == null) {
                return;
            }
            for (let b = 0; b < this.volumeChart.series.count; b++) {
                let c = this.volumeChart.series._inner[b];
                if (c.eu) {
                    continue;
                }
                a(this.volumeChart.series._inner[b], b);
            }
        }
        apu(a) {
            if (this.dataChart == null) {
                return;
            }
            for (let b = 0; b < this.dataChart.series.count; b++) {
                let c = this.dataChart.series._inner[b];
                if (!this.akt(c)) {
                    continue;
                }
                a(c, b);
            }
        }
        apv(a, b) {
            if (this.dataChart == null) {
                return;
            }
            for (let c = 0; c < this.dataChart.series.count; c++) {
                let d = this.dataChart.series._inner[c];
                if (this.akt(d)) {
                    continue;
                }
                let e = this.amu(d, c);
                a(d, e);
            }
            if (b) {
                this.apx(a);
            }
        }
        apx(a) {
            if (this.zoomSliderChart == null) {
                return;
            }
            for (let b = 0; b < this.zoomSliderChart.series.count; b++) {
                let c = this.zoomSliderChart.series._inner[b];
                if (c.eu) {
                    continue;
                }
                a(this.zoomSliderChart.series._inner[b], b);
            }
        }
        amu(a, b) {
            if (a.da != this.dataChart) {
                return b;
            }
            let c = this.bf == null || this.bf.dataSeries == null ? 0 : this.bf.dataSeries.count;
            let d = this.aje == null ? 0 : this.aje.count;
            return b - (c * d);
        }
        u7(a) {
            super.u7(a);
            this.apw(a);
            this.apt(a);
            this.apx(a);
        }
        get volumeChart() {
            return this.aj9;
        }
        set volumeChart(a) {
            let b = this.volumeChart;
            if (a != b) {
                this.aj9 = a;
                this.wd("VolumeChart", b, this.volumeChart);
            }
        }
        aqm() {
            if (this.dataChart == null) {
                return;
            }
            this.volumeChart.series.clear();
            let a = new List$1(Series.$, 0);
            let b = -1;
            for (let c = 0; c < this.dataChart.series.count; c++) {
                let d = this.dataChart.series._inner[c];
                if (this.akt(d) || d.eu) {
                    continue;
                }
                b++;
                let e;
                let f = this.ai3;
                f = this.ai2(f);
                switch (f) {
                    case 2:
                        e = this.aj4();
                        break;
                    case 3:
                        e = this.aj2();
                        break;
                    default:
                    case 1:
                        e = this.aj3();
                        break;
                }
                this.ajk.setCategoryMode(e, 1);
                e.name = "volumeSeries_" + b;
                e.itemsSource = d.itemsSource;
                this.ajk.setXAxis(e, this.volumeXAxis);
                this.ajk.setYAxis(e, this.volumeAxis);
                this.ajk.setValueMemberPath(e, this.bf != null && this.bf.dataSeries != null && this.bf.dataSeries.count > b ? this.bf.dataSeries._inner[b].getMemberPathFor(15) : null);
                e.title = d.title + " Volume";
                e.vk = ArrayExtension.getModulus$1(Brush.$, this.aib, b);
                e.v0 = ArrayExtension.getModulus$1(Brush.$, this.aic, b);
                e.jq = this.al5;
                a.add(e);
            }
            let g = this.hy("volume", false);
            if (g != null) {
                a.o(g);
            }
            for (let h = 0; h < a.count; h++) {
                let i = a._inner[h];
                this.volumeChart.series.add(i);
                this.vn(i, h);
            }
        }
        akq(a) {
            if (!this.akm) {
                return false;
            }
            return this.ajk.matchesType(a);
        }
        aku(a) {
            if (!this.akp) {
                return false;
            }
            return this.aji.matchesType(a);
        }
        akr(a) {
            if (!this.akn) {
                return false;
            }
            return this.ajm.matchesType(a);
        }
        akt(a) {
            if (!this.ako) {
                return false;
            }
            return this.ajr.matchesType(a);
        }
        aql() {
            if (this.dataChart == null) {
                return;
            }
            let a = 0;
            let b = this.ajc == null ? 0 : this.ajc.count;
            let c = this.customIndicatorNames == null ? 0 : this.customIndicatorNames.count;
            let d = b + c;
            for (let e = 0; e < d; e++) {
                let f = new List$1(Series.$, 0);
                let g = this.indicatorCharts._inner[e];
                let h = e >= b;
                let i = h ? this.customIndicatorNames._inner[e - b] : EnumUtil.getName(FinancialIndicatorType_$type, this.ajc._inner[e]);
                let j = -1;
                for (let k = 0; k < this.dataChart.series.count; k++) {
                    let l = this.dataChart.series._inner[k];
                    if (this.akt(l) || l.eu) {
                        continue;
                    }
                    j++;
                    let m;
                    if (h) {
                        let n = this.aj6("Custom");
                        this.ajm.handleCustomIndicatorEvent(n, runOn(this, this.apz));
                        m = n;
                    }
                    else {
                        m = this.aj8(this.ajc._inner[e]);
                    }
                    if (m == null) {
                        continue;
                    }
                    m.name = "indicator_" + a++;
                    this.ajm.setXAxis(m, this.alc._inner[e]);
                    this.ajm.setYAxis(m, this.ala._inner[e]);
                    m.itemsSource = l.itemsSource;
                    this.ajm.setOpenMemberPath(m, this.bf.dataSeries._inner[j].getMemberPathFor(11));
                    this.ajm.setHighMemberPath(m, this.bf.dataSeries._inner[j].getMemberPathFor(12));
                    this.ajm.setLowMemberPath(m, this.bf.dataSeries._inner[j].getMemberPathFor(13));
                    this.ajm.setCloseMemberPath(m, this.bf.dataSeries._inner[j].getMemberPathFor(14));
                    this.ajm.setVolumeMemberPath(m, this.bf.dataSeries._inner[j].getMemberPathFor(15));
                    m.title = l.title + " " + i;
                    m.vk = ArrayExtension.getModulus$1(Brush.$, this.ah5, e);
                    m.jq = this.al1;
                    if (this.akr(m)) {
                        this.ajm.setNegativeBrush(m, ArrayExtension.getModulus$1(Brush.$, this.ah6, e));
                        this.ajm.setDisplayType(m, ArrayExtension.getModulus$1(IndicatorDisplayType_$type, this.ajo, e));
                    }
                    if (this.amw != -2147483648 && this.akr(m)) {
                        this.ajm.setPeriodOverride(m, this.amw);
                    }
                    if (this.akr(m)) {
                        this.ajm.setSmoothingPeriod(m, this.amz);
                    }
                    if (this.akr(m)) {
                        this.ajm.setSignalPeriod(m, this.amy);
                    }
                    if (this.akr(m)) {
                        this.ajm.setShortPeriod(m, this.amx);
                        this.ajm.setLongPeriod(m, this.amv);
                    }
                    this.vn(m, e);
                    f.add(m);
                }
                let o = this.hy(i, false);
                for (let p = 0; p < f.count; p++) {
                    let q = f._inner[p];
                    g.series.add(q);
                }
                if (o != null) {
                    for (let r = 0; r < o.count; r++) {
                        let s = o._inner[r];
                        g.series.add(s);
                        this.vn(s, r);
                    }
                }
            }
        }
        aj6(indicatorName_) {
            return (this.externalObject.createIndicator(indicatorName_ + 'Indicator').i);
        }
        aj8(a) {
            return this.aj6(EnumUtil.getName(FinancialIndicatorType_$type, a));
        }
        aq3(a) {
            if (this.aiw == null) {
                return;
            }
            let b = this.xAxis;
            if (b.actualMinimumValue > b.actualMaximumValue) {
                return;
            }
            this.aiw.as = b.actualMinimumValue;
            this.aiw.ar = b.actualMaximumValue;
            if (a) {
                this.aiw.au = b.visibleMinimum;
                this.aiw.at = b.visibleMaximum;
            }
            this.aiw.bn();
        }
        l5() {
            let a = ((() => {
                let $ret = new FinancialChartVisualData();
                $ret.mainChart = super.l5();
                $ret.volumeChart = this.volumeChart == null ? null : this.volumeChart.y7();
                $ret.toolbar = this.aiw == null ? null : this.aiw.aj();
                $ret.zoomChart = this.zoomSliderChart == null ? null : this.zoomSliderChart.y7();
                return $ret;
            })());
            if (this.indicatorCharts != null) {
                a.indicatorCharts = new List$1(Base.$, 0);
                for (let b of fromEnum(this.indicatorCharts)) {
                    a.indicatorCharts.add1(b.y7());
                }
            }
            if (this.dataChart != null) {
                a.mainChartLeft = this.arc(this.dataChart).x;
                a.mainChartTop = this.arc(this.dataChart).y;
            }
            if (this.volumeChart != null) {
                a.volumeChartLeft = this.arc(this.volumeChart).x;
                a.volumeChartTop = this.arc(this.volumeChart).y;
            }
            if (this.zoomSliderChart != null) {
                a.zoomChartLeft = this.arc(this.zoomSliderChart).x;
                a.zoomChartTop = this.arc(this.zoomSliderChart).y;
            }
            if (this.aiw != null) {
                let c = this.ard(this.aiw);
                a.toolbarLeft = c.left;
                a.toolbarTop = c.top;
                a.toolbarWidth = c.width;
                a.toolbarHeight = c.height;
            }
            if (this.indicatorCharts != null) {
                a.indicatorChartLefts = new List$1(Number_$type, 0);
                a.indicatorChartTops = new List$1(Number_$type, 0);
                for (let d of fromEnum(this.indicatorCharts)) {
                    a.indicatorChartLefts.add(this.arc(d).x);
                    a.indicatorChartTops.add(this.arc(d).y);
                }
            }
            let e = this.arf();
            a.legendLeft = e.left;
            a.legendTop = e.top;
            a.legendWidth = e.width;
            a.legendHeight = e.height;
            a.legend = this.ajg == null ? null : this.ajg.exportVisualData();
            return a;
        }
        anl() {
            let a = this.l5();
            a.scaleByViewport();
            return a.serialize();
        }
        aj7(overlayName_) {
            return (this.externalObject.createOverlay(overlayName_ + 'Overlay').i);
        }
        aq2() {
            if (this.dataChart == null) {
                return;
            }
            let a = new List$1(Series.$, 0);
            for (let b of fromEnum(this.dataChart.series)) {
                if (this.akt(b)) {
                    a.add(b);
                }
            }
            for (let c of fromEnum(a)) {
                this.dataChart.series.remove(c);
            }
            if (this.aje == null) {
                return;
            }
            let d = new List$1(Series.$, 0);
            let e = -1;
            for (let f = 0; f < this.dataChart.series.count; f++) {
                let g = this.dataChart.series._inner[f];
                if (this.akt(g) || g.eu) {
                    continue;
                }
                e++;
                for (let h = 0; h < this.aje.count; h++) {
                    let i = this.aje._inner[h];
                    let j;
                    switch (i) {
                        case 1:
                            j = this.aj7(EnumUtil.getName(FinancialOverlayType_$type, i));
                            break;
                        default:
                        case 0:
                            j = this.aj7(EnumUtil.getName(FinancialOverlayType_$type, i));
                            break;
                    }
                    j.name = g.name + "_" + EnumUtil.getName(FinancialOverlayType_$type, i);
                    this.ajr.setXAxis(j, this.xAxis);
                    this.ajr.setYAxis(j, this.yAxis);
                    j.itemsSource = g.itemsSource;
                    let k = e * this.aje.count + h;
                    j.vk = ArrayExtension.getModulus$1(Brush.$, this.ah9, k);
                    j.v0 = ArrayExtension.getModulus$1(Brush.$, this.aia, k);
                    j.jq = this.al3;
                    j.title = g.title + " " + EnumUtil.getName(FinancialOverlayType_$type, i);
                    let l = g;
                    if (l == null) {
                        continue;
                    }
                    let m = this.bf.dataSeries._inner[e];
                    this.ajr.setOpenMemberPath(j, m.getMemberPathFor(11));
                    this.ajr.setHighMemberPath(j, m.getMemberPathFor(12));
                    this.ajr.setLowMemberPath(j, m.getMemberPathFor(13));
                    this.ajr.setCloseMemberPath(j, m.getMemberPathFor(14));
                    this.ajr.setVolumeMemberPath(j, m.getMemberPathFor(15));
                    d.add(j);
                }
            }
            let n = new Array(this.dataChart.series.count);
            this.dataChart.series.copyTo(n, 0);
            this.dataChart.skipDataCleanup = true;
            this.dataChart.series.clear();
            this.dataChart.skipDataCleanup = false;
            for (let o = 0; o < n.length; o++) {
                n[o].index = -1;
            }
            d.o(n);
            for (let p = 0; p < d.count; p++) {
                let q = d._inner[p];
                this.dataChart.series.add(q);
                this.vn(q, p);
            }
        }
        aq0() {
            if (this.akz) {
                return;
            }
            this.akz = true;
            if (this.indicatorCharts != null) {
                let a = this.indicatorCharts;
                this.indicatorCharts = null;
                for (let b of fromEnum(a)) {
                    this.aqg(b);
                }
            }
            if ((this.ajc == null || this.ajc.count == 0) && (this.customIndicatorNames == null || this.customIndicatorNames.count == 0)) {
                this.indicatorCharts = null;
                if (this.ala != null) {
                    this.ala.clear();
                }
                if (this.alc != null) {
                    this.alc.clear();
                }
                this.aqr();
                this.aq1();
                this.akz = false;
                return;
            }
            if (this.indicatorCharts == null) {
                this.indicatorCharts = new List$1(XamDataChart.$, 0);
            }
            this.indicatorCharts.clear();
            this.ala.clear();
            this.alc.clear();
            let c = this.ajc == null ? 0 : this.ajc.count;
            let d = this.customIndicatorNames == null ? 0 : this.customIndicatorNames.count;
            let e = c + d;
            for (let f = 0; f < e; f++) {
                let g = new XamDataChart();
                this.indicatorCharts.add(g);
                this.aqe(g, null);
                let h = f >= c;
                if (h) {
                    g.mc = this.customIndicatorNames._inner[f - c];
                }
                else {
                    g.mc = this.ann(this.ajc._inner[f]);
                }
                if (this.indicatorAxis != null) {
                    let i;
                    let j;
                    if (f == 0) {
                        i = this.indicatorAxis;
                        j = this.indicatorXAxis;
                    }
                    else {
                        i = new NumericYAxis();
                        if (!this.indicatorXAxis.ce) {
                            j = this.aii(0);
                        }
                        else {
                            j = this.aii(1);
                        }
                    }
                    j.name = "indicatorXAxis_" + f;
                    i.name = "indicatorAxis_" + f;
                    g.axes.add(i);
                    g.axes.add(j);
                    this.ala.add(i);
                    this.alc.add(j);
                    if (this.gk) {
                        this.af9(i);
                    }
                    if (this.gk) {
                        this.af7(j);
                    }
                }
            }
            this.aqr();
            this.aql();
            if (this.aiw != null) {
                this.aiw.ae = this.ajc;
            }
            this.app();
            this.aq1();
            this.akz = false;
        }
        vf() {
            super.vf();
            this.af7(this.xAxis);
            this.af7(this.volumeXAxis);
            if (this.alc != null) {
                for (let a of fromEnum(this.alc)) {
                    this.af7(a);
                }
            }
            this.af9(this.yAxis);
            this.af9(this.volumeAxis);
            if (this.ala != null) {
                for (let b of fromEnum(this.ala)) {
                    this.af9(b);
                }
            }
            this.af7(this.zoomSliderXAxis);
            this.af9(this.zoomSliderAxis);
        }
        get_hd() {
            return !this.akx;
        }
        get ak5() {
            return (this.externalObject._dynamicContent);
        }
        aq8(a, b) {
            this.aqu(a, b, this.amm);
            this.app();
            if (this.zoomSliderChart != null) {
                this.zoomSliderChart.axes.add(this.zoomSliderAxis);
                this.zoomSliderChart.axes.add(this.zoomSliderXAxis);
            }
            this.aqn();
            this.zoomSliderXAxis.itemsSource = this.xAxis.itemsSource;
            this.aqs();
            this.aq9(a, b);
        }
        aqn() {
            if (this.dataChart == null || this.zoomSliderChart == null) {
                return;
            }
            this.zoomSliderChart.series.clear();
            let a = new List$1(Series.$, 0);
            for (let b = 0; b < this.dataChart.series.count; b++) {
                let c = this.dataChart.series._inner[b];
                if (this.akt(c) || c.eu) {
                    continue;
                }
                let d;
                let e = this.aja;
                e = this.ai9(e);
                let f = this.amu(c, b);
                if (e == 1) {
                    switch (this.ai0(this.bf != null && this.bf.dataSeries != null && this.bf.dataSeries.count > f ? this.bf.dataSeries._inner[f] : null)) {
                        case 1:
                            e = 2;
                            break;
                        case 2:
                            e = 3;
                            break;
                        case 3:
                            e = 4;
                            break;
                        case 4:
                            e = 5;
                            break;
                    }
                }
                switch (e) {
                    case 2:
                        d = this.aj5();
                        this.aji.setDisplayType(d, 1);
                        break;
                    case 3:
                        d = this.aj5();
                        this.aji.setDisplayType(d, 0);
                        break;
                    case 5:
                        d = this.aj4();
                        break;
                    case 6:
                        d = this.aj2();
                        break;
                    default:
                    case 4:
                        d = this.aj3();
                        break;
                }
                let g = this.bf != null && this.bf.dataSeries != null && this.bf.dataSeries.count > f ? this.bf.dataSeries._inner[f] : null;
                if (d.e0 && !d.e8) {
                    this.ajk.setCategoryMode(d, 1);
                    this.ajk.setXAxis(d, this.zoomSliderXAxis);
                    this.ajk.setYAxis(d, this.zoomSliderAxis);
                    this.ajk.setValueMemberPath(d, g == null ? null : this.ano(g));
                }
                else if (d.e8) {
                    this.aji.setCategoryMode(d, 1);
                    this.aji.setXAxis(d, this.zoomSliderXAxis);
                    this.aji.setYAxis(d, this.zoomSliderAxis);
                    if (g != null) {
                        this.aji.setOpenMemberPath(d, g.getMemberPathFor(11));
                        this.aji.setHighMemberPath(d, g.getMemberPathFor(12));
                        this.aji.setLowMemberPath(d, g.getMemberPathFor(13));
                        this.aji.setCloseMemberPath(d, g.getMemberPathFor(14));
                        this.aji.setVolumeMemberPath(d, g.getMemberPathFor(15));
                    }
                }
                d.name = "zoomSliderSeries_" + f;
                d.itemsSource = c.itemsSource;
                d.title = c.title;
                d.jq = this.kg;
                a.add(d);
            }
            for (let h = 0; h < a.count; h++) {
                let i = a._inner[h];
                this.zoomSliderChart.series.add(i);
                this.vn(i, h);
            }
        }
        v3(a, b, c) {
            super.v3(a, b, c);
            if (a == null || !b) {
                return;
            }
            let d = true;
            let e = true;
            switch (c) {
                case "Brushes":
                case "Outlines":
                    d = e = false;
                    break;
            }
            if (this.indicatorCharts != null && d) {
                for (let f of fromEnum(this.indicatorCharts)) {
                    a(f);
                }
            }
            if (this.volumeChart != null && e) {
                a(this.volumeChart);
            }
            if (this.zoomSliderChart != null) {
                a(this.zoomSliderChart);
            }
        }
        apz(a, b) {
            let c = b;
            let d = a;
            let e = -1;
            if (this.indicatorCharts != null) {
                e = this.indicatorCharts.indexOf(d.da);
            }
            e -= this.ajc == null ? 0 : this.ajc.count;
            if (this.applyCustomIndicators != null) {
                this.applyCustomIndicators(this, new FinancialChartCustomIndicatorArgs(c, d, e));
            }
        }
        aqw(a, b, c) {
            if (a != null) {
                if (b != null) {
                    a.axes.remove(b);
                }
                a.axes.add(c);
            }
            if (this.gk) {
                this.af7(c);
            }
        }
        get ak4() {
            return TypeRegistrar.isRegistered("IgxZoomSliderComponent");
        }
        ap0(a, b) {
            this.aq0();
        }
        akv(a, b) {
            if (b <= (0)) {
                return false;
            }
            switch (a) {
                case 5: return true;
                case 4:
                case 3: return b >= timeSpanFromDays(365);
                case 2: return b >= timeSpanFromDays(180);
                case 1: return b >= timeSpanFromDays(90);
                case 0: return b >= timeSpanFromDays(30);
            }
            return false;
        }
        aqq() {
            let a = this.aiu != null ? this.aiu : new FinancialChartRangeSelectorOptionCollection(1, [5, 4, 3, 2, 1, 0]);
            let b = new FinancialChartRangeSelectorOptionCollection(0);
            let c = this.xAxis;
            let d = +(c.actualMaximumValue) - +(c.actualMinimumValue);
            for (let e of fromEnum(a)) {
                if (this.akv(e, d)) {
                    b.add(e);
                }
            }
            this.ait = b;
            if (this.aiw != null) {
                this.aiw.u = this.ait;
            }
        }
        ap4(a, b) {
            this.aqq();
        }
        ap9(a, b) {
            this.aje = this.aiw.ag;
        }
        ap8(a, b) {
            this.ajc = this.aiw.ae;
        }
        ap2(a, b) {
            this.aq0();
        }
        ap3(a, b) {
            this.aq2();
        }
        aqd(a, b) {
            let c = a;
            if (c.bg == null) {
                return;
            }
            if (this.akx) {
                this.aqp(c.bg);
            }
        }
        aqg(a) {
            SyncManager.e(a);
            a.axes.clear();
            a.series.clear();
            a.gridAreaRectChanged = delegateRemove(a.gridAreaRectChanged, runOn(this, this.ap1));
            a.provideContainer(null);
            if (this.volumeChart == null && this.indicatorCharts == null) {
                this.yAxis.eu = this.volumeAxis.eu = this.indicatorAxis.eu = 0;
                this.xAxis.az.visibility = this.ahv;
            }
        }
        aqe(a, b) {
            let c = a != this.zoomSliderChart;
            if (c) {
                if (this.dataChart != null) {
                    a.w0 = new Rect(0, this.dataChart.wh.x, a.w0.y, this.dataChart.wh.width, a.w0.height);
                }
                let d = ((() => {
                    let $ret = new SyncSettings();
                    $ret.syncChannel = "one";
                    $ret.synchronizeHorizontally = true;
                    $ret.synchronizeVertically = false;
                    return $ret;
                })());
                SyncManager.d(a, d);
                SyncManager.c(a);
            }
            a.gridAreaRectChanged = delegateCombine(a.gridAreaRectChanged, runOn(this, this.ap1));
            this.vh(a, b);
        }
        app() {
            if (this.indicatorCharts != null || this.volumeChart != null) {
                this.af5(this.xAxis, (a) => a.visibility = 1);
            }
            for (let a = 0; a < this.alc.count; a++) {
                let b = this.alc._inner[a];
                let c = a < this.alc.count - 1 || this.volumeChart != null;
                this.af5(b, (d) => d.visibility = c ? 1 : 0);
            }
        }
        aqu(a, b, c) {
            if (a != null) {
                this.aqg(a);
            }
            if (b != null) {
                this.aqe(b, c);
            }
        }
        aq6(a, b) {
            this.aqu(a, b, this.aml);
            this.app();
            if (this.volumeChart != null) {
                if (this.volumeAxis != null) {
                    this.volumeChart.axes.add(this.volumeAxis);
                    this.volumeChart.axes.add(this.volumeXAxis);
                }
                this.aqm();
                this.volumeXAxis.itemsSource = this.xAxis.itemsSource;
            }
            this.aq7(a, b);
        }
        ap5(a, b) {
            this.aq4();
        }
        aq4() {
            if (this.aiw == null || +(this.aiw.au) == +(dateMaxValue()) || +(this.aiw.at) == +(dateMinValue()) || this.dataChart == null) {
                return;
            }
            let a = this.xAxis;
            let b = a.getWindowRectForSelection(this.aiw.au, this.aiw.at);
            if (b.width == 0 || isNaN_(b.width) || isInfinity(b.width)) {
                return;
            }
            this.aky = true;
            this.dataChart.w0 = new Rect(0, b.left, this.dataChart.w0.top, b.width, this.dataChart.w0.height);
            if (this.ake != null) {
                this.ake.windowRect = this.dataChart.wh;
            }
            if (this.akx) {
                this.aqp(this.dataChart);
            }
            this.aky = false;
        }
        aqc(a, b) {
            this.aqq();
            this.aq3(!this.aky);
        }
        apy(a, b) {
            if (!this.aky) {
                if (this.akx) {
                    this.aqp(a);
                }
                let c = false;
                let d = this.wm(() => this.aq3(true), c);
                c = d.p1;
                if (this.ake != null) {
                    this.ake.windowRect = this.dataChart.wh;
                }
            }
        }
        aqy(a, b, c, d) {
            if (a == null || b == null) {
                return;
            }
            if (c != -1) {
                this.aky = true;
                a.w0 = new Rect(0, d, a.wh.top, c, a.wh.height);
                this.aky = false;
            }
            let e = 1.7976931348623157E+308;
            let f = -1.7976931348623157E+308;
            let g = new Rect(0, 0, 0, 1, 1);
            let h = new ScalerParams(0, g, g, this.yAxis.ch, a.wl);
            for (let i of fromEnum(a.series)) {
                h.b = i.iz();
                let j = i.az(a.wh);
                let k = j == null || j.c == 1.7976931348623157E+308 || isNaN_(j.c);
                if (k) {
                    continue;
                }
                let l = b.el(j.c, h);
                let m = b.el(j.b, h);
                f = Math.max(f, l);
                e = Math.min(e, m);
            }
            let n = a.wh.width;
            if (c != -1) {
                n = c;
            }
            let o = a.wh.left;
            if (d != -1) {
                o = d;
            }
            if (e == 1.7976931348623157E+308 || f == -1.7976931348623157E+308 || isNaN_(e) || isNaN_(f)) {
                return;
            }
            this.aky = true;
            let p = new Rect(0, o, e, n, f - e);
            a.w0 = p;
            this.aky = false;
        }
        aqx(a) {
            if (a == null) {
                return;
            }
            if (a == this.dataChart) {
                this.aqy(this.dataChart, this.yAxis, -1, -1);
                if (this.volumeChart != null) {
                    this.aqy(this.volumeChart, this.volumeAxis, this.dataChart.wh.width, this.dataChart.wh.left);
                }
            }
            else if (a == this.volumeChart) {
                this.aqy(this.volumeChart, this.volumeAxis, -1, -1);
                this.aqy(this.dataChart, this.yAxis, this.volumeChart.wh.width, this.volumeChart.wh.left);
            }
        }
        aqp(a) {
            this.wl(() => this.aqx(a));
        }
        ap6(a, b) {
            if (this.akx) {
                this.aqp(a);
            }
        }
        aq5() {
            if (!this.ak5) {
                return;
            }
            this.aps();
            if (this.aja == 0) {
                this.resetZoom();
                this.zoomSliderChart = null;
                this.amm.rootWrapper.removeChildren();
            }
            else if (this.zoomSliderChart == null) {
                this.zoomSliderChart = ((() => {
                    let $ret = new XamDataChart();
                    $ret.name = "ZoomSliderChart";
                    return $ret;
                })());
                this.aqs();
            }
            else {
                this.aqn();
            }
        }
        aps() {
            let container_ = this.amm.rootWrapper.getNativeElement();
            let containerParent_ = container_.parentElement;
            if (this.ake != null && containerParent_ != null && !this.ak6) {
                this.ak6 = true;
                if (TypeRegistrar.isRegistered("IgxZoomSliderComponent")) {
                    let z_ = this.ake;
                    let f_ = this.externalObject;
                    let sliderComponent_ = TypeRegistrar.get("IgxZoomSliderComponent");
                    let sliderInstance_ = TypeRegistrar.create("IgxZoomSliderComponent");
                    sliderInstance_._implementation = z_;
                    sliderComponent_._staticStyling(container_, sliderInstance_, f_);
                }
            }
        }
        aqz() {
            if (this.ai5 != 1) {
                return;
            }
            this.agb((a) => {
                let b;
                b = a.breaks;
                b.clear();
                if (this.xAxisBreaks == null) {
                    return;
                }
                for (let c of fromEnum(this.xAxisBreaks)) {
                    b.add(c);
                }
            });
        }
        xf(a, b, c) {
            super.xf(a, b, c);
            if (this.bf.dataSeries.count > 0) {
                if (this.ai5 == 1 && stringIsNullOrEmpty(this.nz)) {
                    this.ce.setXMemberPath(a, c.getMemberPathFor(17));
                }
                if (stringIsNullOrEmpty(this.n1)) {
                    this.ce.setYMemberPath(a, this.ano(c));
                }
                if (stringIsNullOrEmpty(this.nm)) {
                    this.ce.setLabelMemberPath(a, this.ano(c));
                }
                if (stringIsNullOrEmpty(this.ni)) {
                    this.ce.setContentMemberPath(a, this.ano(c));
                }
            }
        }
        ann(a) {
            switch (a) {
                case 0: return "Absolute Volume Oscillator";
                case 1: return "Accumulation/Distribution Indicator";
                case 2: return "Average Directional Index";
                case 3: return "Average True Range Indicator";
                case 4: return "Bollinger Bandwidth";
                case 5: return "Chaikin Oscillator";
                case 6: return "Chaikin Volatility Indicator";
                case 7: return "Commodity Channel Index";
                case 8: return "Detrended Price Oscillator";
                case 9: return "Ease of Movement Indicator";
                case 10: return "Fast Stochastic Oscillator";
                case 11: return "Force Index Indicator";
                case 12: return "Full Stochastic Oscillator";
                case 13: return "Market Facilitation Index";
                case 14: return "Mass Index Indicator";
                case 15: return "Median Price Indicator";
                case 16: return "Money Flow Index";
                case 17: return "MACD Indicator";
                case 18: return "Negative Volume Index";
                case 19: return "On Balance Volume Indicator";
                case 20: return "Percentage Price Oscillator";
                case 21: return "Percentage Volume Oscillator";
                case 22: return "Positive Volume Index";
                case 23: return "Price Volume Trend";
                case 24: return "ROC - Rate of Change Indicator";
                case 25: return "RSI - Relative Strength Index";
                case 26: return "Slow Stochastic Oscillator";
                case 27: return "Standard Deviation Indicator";
                case 28: return "Stoch RSI";
                case 29: return "TRIX Indicator";
                case 30: return "Typical Price Indicator";
                case 31: return "Ultimate Oscillator";
                case 32: return "Weighted Close Indicator";
                case 33: return "Williams %R Indicator";
                default: return "Unknown";
            }
        }
        af7(a) {
            super.af7(a);
            let b = a;
            this.aqf(b);
            if (a.bg != null) {
                for (let c of fromEnum(a.bg.series)) {
                    if (this.akq(c)) {
                        this.ajk.setXAxis(c, b);
                    }
                    else if (this.aku(c)) {
                        this.aji.setXAxis(c, b);
                    }
                    else if (this.akr(c)) {
                        this.ajm.setXAxis(c, b);
                    }
                    else if (this.akt(c)) {
                        this.ajr.setXAxis(c, b);
                    }
                }
            }
            this.aqj((d) => {
                d.zoomMaximumCategoryRange = this.al6;
                d.zoomMaximumItemSpan = this.al7;
                d.zoomToCategoryRange = this.al8;
                d.zoomToCategoryStart = this.al9;
                d.zoomToItemSpan = this.ama;
            });
            let d = a == this.zoomSliderXAxis;
            if (d) {
                a.jz = this.arb;
                a.et = this.amh;
                this.af5(a, (e) => e.visibility = 1);
            }
            let e = a;
            e.minimumValue = this.ali;
            e.maximumValue = this.alh;
            a.b1 = this.ak0;
        }
        af9(a) {
            super.af9(a);
            if (a.bg != null && a == this.yAxis) {
                for (let b of fromEnum(a.bg.series)) {
                    if (this.akq(b)) {
                        this.ajk.setYAxis(b, this.yAxis);
                    }
                    else if (this.aku(b)) {
                        this.aji.setYAxis(b, this.yAxis);
                    }
                    else if (this.akr(b)) {
                        this.ajm.setYAxis(b, this.yAxis);
                    }
                    else if (this.akt(b)) {
                        this.ajr.setYAxis(b, this.yAxis);
                    }
                }
            }
            a.lf = this.ak1;
            a.mc = this.amf;
            a.mb = this.ame;
            if (a == this.yAxis) {
                a.l8 = this.amd;
            }
            let c = a == this.zoomSliderAxis;
            if (c) {
                this.af5(a, (d) => d.visibility = 1);
            }
            a.b1 = this.ak2;
        }
        aqf(a) {
            a.itemsSource = this.dataChart != null && this.dataChart.series.count > 0 ? this.dataChart.series._inner[0].itemsSource : null;
            a.f2 = XYChart.adq(a, this.bf.dataSeries);
            if (this.bf.dataSeries.count > 0) {
                let b = this.bf.dataSeries._inner[0].getMemberPathFor(17);
                a.h1(b);
            }
        }
        vn(a, b) {
            if (a == null) {
                return;
            }
            let c = this.zoomSliderChart == a.da;
            let d = this.dataChart != null && this.dataChart.series.contains(a);
            if (d && !a.eu && !this.akt(a)) {
                a.l5 = "Financial Series";
            }
            super.vn(a, b);
            if ((d || c) && a.fn) {
                a.r7(this.ah7 != null ? ArrayExtension.getModulus$1(Brush.$, this.ah7, b) : null, this.ah8 != null ? ArrayExtension.getModulus$1(Brush.$, this.ah8, b) : null);
            }
            let e = this.akr(a);
            if (this.akt(a)) {
                a.vk = this.ah9 != null ? ArrayExtension.getModulus$1(Brush.$, this.ah9, b) : null;
                a.v0 = this.aia != null ? ArrayExtension.getModulus$1(Brush.$, this.aia, b) : null;
                a.jq = this.al3;
            }
            else if (e) {
                a.vk = this.ah5 != null ? ArrayExtension.getModulus$1(Brush.$, this.ah5, b) : null;
                a.jq = this.al1;
            }
            else if (!a.eu && (d || c)) {
                a.vk = this.z != null ? ArrayExtension.getModulus$1(Brush.$, this.z, b) : null;
                a.v0 = this.ad != null ? ArrayExtension.getModulus$1(Brush.$, this.ad, b) : null;
            }
            let f = this.volumeChart != null && this.volumeChart == a.da;
            if (f) {
                a.jq = this.al5;
            }
            a.legend = c || f || e || !a.isUsableInLegend ? null : this.legend != null ? this.legend : this.aks ? this.ajg : null;
        }
        vo(a, b) {
            super.vo(a, b);
            if (a == null) {
                return;
            }
        }
        wd(a, b, c) {
            super.wd(a, b, c);
            switch (a) {
                case "YAxisIsLogarithmic":
                    this.yAxis.lo = this.ak3;
                    if (this.volumeAxis != null) {
                        this.volumeAxis.lo = this.ak3;
                    }
                    if (this.zoomSliderAxis != null) {
                        this.zoomSliderAxis.lo = this.ak3;
                    }
                    break;
                case "YAxisLogarithmBase":
                    this.yAxis.mm = this.am1;
                    if (this.volumeAxis != null) {
                        this.volumeAxis.mm = this.am1;
                    }
                    if (this.zoomSliderAxis != null) {
                        this.zoomSliderAxis.mm = this.am1;
                    }
                    break;
                case "VolumeType":
                    let d = EnumUtil.getEnumValue(FinancialChartVolumeType_$type, b);
                    if (this.ai3 == 0) {
                        this.volumeChart = null;
                    }
                    else if (this.volumeChart == null) {
                        this.volumeChart = ((() => {
                            let $ret = new XamDataChart();
                            $ret.name = "VolumeChart";
                            return $ret;
                        })());
                    }
                    else {
                        this.aqm();
                    }
                    break;
                case "VolumeChart":
                    this.aq6(typeCast(XamDataChart.$, b), typeCast(XamDataChart.$, c));
                    break;
                case "DataChart":
                    if (typeCast(XamDataChart.$, b) !== null) {
                        let e = b;
                        e.gridAreaRectChanged = delegateRemove(e.gridAreaRectChanged, runOn(this, this.ap1));
                        e.actualWindowRectChanged = delegateRemove(e.actualWindowRectChanged, runOn(this, this.apy));
                        e.seriesDataUpdated = delegateRemove(e.seriesDataUpdated, runOn(this, this.ap6));
                    }
                    if (this.dataChart != null) {
                        let f = this.dataChart;
                        f.gridAreaRectChanged = delegateCombine(f.gridAreaRectChanged, runOn(this, this.ap1));
                        let g = this.dataChart;
                        g.actualWindowRectChanged = delegateCombine(g.actualWindowRectChanged, runOn(this, this.apy));
                        let h = this.dataChart;
                        h.seriesDataUpdated = delegateCombine(h.seriesDataUpdated, runOn(this, this.ap6));
                    }
                    this.aq5();
                    break;
                case "XAxisMode":
                    this.xAxis = this.aii(this.ai5);
                    this.xAxis.name = "xAxis";
                    this.volumeXAxis = this.aii(this.ai5);
                    this.volumeXAxis.name = "volumeXAxis";
                    this.indicatorXAxis = this.aii(this.ai5);
                    this.indicatorXAxis.name = "indicatorXAxis_0";
                    this.zoomSliderXAxis = this.aii(this.ai5);
                    this.zoomSliderXAxis.name = "zoomSliderXAxis";
                    this.af5(this.zoomSliderXAxis, (i) => i.visibility = 1);
                    this.app();
                    if (this.ai5 == 1) {
                        this.aqz();
                    }
                    break;
                case "YAxisMode":
                    this.yAxis = this.ajw(this.ai7);
                    this.yAxis.name = "yAxis";
                    this.zoomSliderAxis = this.ajw(this.ai7);
                    this.zoomSliderAxis.name = "zoomSliderAxis";
                    this.volumeAxis = this.ajw(this.ai7);
                    this.volumeAxis.name = "volumeAxis";
                    break;
                case "Toolbar":
                    let i = typeCast(FinancialChartToolbar.$, b);
                    if (i != null) {
                        i.rangeChanged = delegateRemove(i.rangeChanged, runOn(this, this.ap5));
                        i.indicatorTypesChanged = delegateRemove(i.indicatorTypesChanged, runOn(this, this.ap8));
                        i.overlayTypesChanged = delegateRemove(i.overlayTypesChanged, runOn(this, this.ap9));
                    }
                    if (this.aiw != null) {
                        this.aiw.ae = this.ajc;
                        this.aiw.ag = this.aje;
                        this.aiw.u = this.ait;
                        this.aq3(true);
                        let j = this.aiw;
                        j.rangeChanged = delegateCombine(j.rangeChanged, runOn(this, this.ap5));
                        let k = this.aiw;
                        k.indicatorTypesChanged = delegateCombine(k.indicatorTypesChanged, runOn(this, this.ap8));
                        let l = this.aiw;
                        l.overlayTypesChanged = delegateCombine(l.overlayTypesChanged, runOn(this, this.ap9));
                    }
                    break;
                case "XAxis":
                    let m = typeCast(CategoryAxisBase.$, b);
                    if (m != null) {
                        if (this.dataChart != null) {
                            this.dataChart.axes.remove(m);
                        }
                    }
                    let n = typeCast(ITimeRangeSelectorAxis_$type, b);
                    if (n != null) {
                        n.visibleRangeChanged = delegateRemove(n.visibleRangeChanged, runOn(this, this.aqc));
                    }
                    if (this.dataChart != null) {
                        this.dataChart.axes.add(this.xAxis);
                    }
                    if (this.gk) {
                        this.af7(this.xAxis);
                        this.u4();
                    }
                    this.aq3(false);
                    this.aq4();
                    this.aqq();
                    let o = this.xAxis;
                    o.visibleRangeChanged = delegateCombine(o.visibleRangeChanged, runOn(this, this.aqc));
                    break;
                case "XAxisZoomMaximumCategoryRange":
                    this.aqj((p) => p.zoomMaximumCategoryRange = this.al6);
                    break;
                case "XAxisZoomMaximumItemSpan":
                    this.aqj((p) => p.zoomMaximumItemSpan = this.al7);
                    break;
                case "XAxisZoomToCategoryRange":
                    this.aqj((p) => p.zoomToCategoryRange = this.al8);
                    break;
                case "XAxisZoomToCategoryStart":
                    this.aqj((p) => p.zoomToCategoryStart = this.al9);
                    break;
                case "XAxisZoomToItemSpan":
                    this.aqj((p) => p.zoomToItemSpan = this.ama);
                    break;
                case "ChartType":
                    this.u8();
                    break;
                case "VolumeXAxis":
                    this.aqw(this.volumeChart, typeCast(Axis.$, b), this.volumeXAxis);
                    break;
                case "ZoomSliderXAxis":
                    this.aqw(this.zoomSliderChart, typeCast(Axis.$, b), this.zoomSliderXAxis);
                    break;
                case "IndicatorXAxis":
                    this.aq0();
                    break;
                case "YAxis":
                    let p = typeCast(NumericYAxis.$, b);
                    if (p != null) {
                        if (this.dataChart != null) {
                            this.dataChart.axes.remove(p);
                        }
                    }
                    if (this.dataChart != null) {
                        this.dataChart.axes.add(this.yAxis);
                    }
                    if (this.gk) {
                        this.af9(this.yAxis);
                        this.af9(this.yAxis);
                    }
                    let q = this.yAxis;
                    q.rangeChanged = delegateCombine(q.rangeChanged, runOn(this, this.aqd));
                    break;
                case "VolumeAxis":
                    let r = typeCast(Axis.$, b);
                    if (this.volumeChart != null && r != null) {
                        this.volumeChart.axes.remove(r);
                    }
                    if (this.volumeChart != null && this.volumeAxis != null) {
                        this.volumeChart.axes.add(this.volumeAxis);
                        this.aqm();
                    }
                    if (this.gk) {
                        this.af9(this.volumeAxis);
                    }
                    let s = this.volumeAxis;
                    s.rangeChanged = delegateCombine(s.rangeChanged, runOn(this, this.aqd));
                    break;
                case "IndicatorAxis":
                    if (this.indicatorCharts != null) {
                        for (let t = 0; t < this.indicatorCharts.count; t++) {
                            let u = this.indicatorCharts._inner[t];
                            let v = new List$1(Axis.$, 0);
                            for (let w of fromEnum(u.axes)) {
                                if (typeCast(NumericYAxis.$, w) !== null) {
                                    v.add(w);
                                }
                            }
                            for (let x of fromEnum(v)) {
                                u.axes.remove(x);
                            }
                            let y = null;
                            if (t == 0) {
                                y = this.indicatorAxis;
                            }
                            else if (this.ai7 == 1) {
                                y = this.ajw(this.ai7);
                            }
                            else if (typeCast(NumericYAxis.$, this.indicatorAxis) !== null) {
                                y = new NumericYAxis();
                            }
                            if (y != null) {
                                u.axes.add(y);
                            }
                            if (this.gk) {
                                this.af9(y);
                            }
                        }
                    }
                    break;
                case "IsWindowSyncedToVisibleRange":
                    if (this.dataChart != null) {
                        this.dataChart.xy = this.he && this.hd;
                    }
                    if (this.volumeChart != null) {
                        this.volumeChart.xy = this.he && this.hd;
                    }
                    if (this.akx) {
                        this.aqx(this.dataChart);
                    }
                    else {
                        this.volumeChart.y5 = 1;
                    }
                    break;
                case "IndicatorTypes":
                    let z = typeCast(ObservableCollection$1.$.specialize(FinancialIndicatorType_$type), b);
                    if (z != null) {
                        z.collectionChanged = delegateRemove(z.collectionChanged, runOn(this, this.ap2));
                    }
                    let aa = typeCast(ObservableCollection$1.$.specialize(FinancialIndicatorType_$type), c);
                    if (aa != null) {
                        aa.collectionChanged = delegateCombine(aa.collectionChanged, runOn(this, this.ap2));
                    }
                    this.aq0();
                    break;
                case "OverlayTypes":
                    let ab = typeCast(ObservableCollection$1.$.specialize(FinancialOverlayType_$type), b);
                    if (ab != null) {
                        ab.collectionChanged = delegateRemove(ab.collectionChanged, runOn(this, this.ap3));
                    }
                    let ac = typeCast(ObservableCollection$1.$.specialize(FinancialOverlayType_$type), c);
                    if (ac != null) {
                        ac.collectionChanged = delegateCombine(ac.collectionChanged, runOn(this, this.ap3));
                    }
                    this.aq2();
                    break;
                case "YAxisAbbreviateLargeNumbers":
                    this.agg((ad) => ad.lf = this.ak1);
                    break;
                case "YAxisMinimumValue":
                    this.agh((ad) => ad.mc = this.amf, false);
                    break;
                case "YAxisMaximumValue":
                    this.agh((ad) => ad.mb = this.ame, false);
                    break;
                case "YAxisInterval":
                    this.agh((ad) => ad.l8 = this.amd, false);
                    break;
                case "Thickness":
                case "ZoomSliderType":
                    this.aq5();
                    break;
                case "ZoomSliderChart":
                    if (!this.ak4) {
                        return;
                    }
                    this.aq8(typeCast(XamDataChart.$, b), typeCast(XamDataChart.$, c));
                    break;
                case "NegativeBrushes":
                case "NegativeOutlines":
                    this.apv((ad, ae) => {
                        if (ad.fn) {
                            ad.r7(this.ah7 != null ? ArrayExtension.getModulus$1(Brush.$, this.ah7, ae) : null, this.ah8 != null ? ArrayExtension.getModulus$1(Brush.$, this.ah8, ae) : null);
                        }
                    }, true);
                    break;
                case "OverlayBrushes":
                    this.apu((ad, ae) => ad.vk = this.ah9 != null ? ArrayExtension.getModulus$1(Brush.$, this.ah9, ae) : null);
                    break;
                case "OverlayOutlines":
                    this.apu((ad, ae) => ad.v0 = this.aia != null ? ArrayExtension.getModulus$1(Brush.$, this.aia, ae) : null);
                    break;
                case "OverlayThickness":
                    this.apu((ad, ae) => ad.jq = this.al3);
                    break;
                case "OverlayMultiplier":
                    this.apu((ad, ae) => this.ajr.setMultiplier(ad, this.al2));
                    break;
                case "VolumeBrushes":
                    this.apw((ad, ae) => ad.vk = ArrayExtension.getModulus$1(Brush.$, this.aib, ae));
                    break;
                case "VolumeOutlines":
                    this.apw((ad, ae) => ad.v0 = ArrayExtension.getModulus$1(Brush.$, this.aic, ae));
                    break;
                case "VolumeThickness":
                    this.apw((ad, ae) => ad.jq = this.al5);
                    break;
                case "IndicatorNegativeBrushes":
                    this.apt((ad, ae) => this.ajm.setNegativeBrush(ad, ArrayExtension.getModulus$1(Brush.$, this.ah6, ae)));
                    break;
                case "IndicatorBrushes":
                    this.apt((ad, ae) => ad.vk = ArrayExtension.getModulus$1(Brush.$, this.ah5, ae));
                    break;
                case "IndicatorThickness":
                    this.apt((ad, ae) => ad.jq = this.al1);
                    break;
                case "IndicatorDisplayTypes":
                    this.apt((ad, ae) => this.ajm.setDisplayType(ad, ArrayExtension.getModulus$1(IndicatorDisplayType_$type, this.ajo, ae)));
                    break;
                case "IndicatorPeriod":
                    this.apt((ad, ae) => {
                        if (this.amw == -2147483648) {
                            return;
                        }
                        this.ajm.setPeriodOverride(ad, this.amw);
                    });
                    break;
                case "IndicatorMultiplier":
                    this.apt((ad, ae) => this.ajm.setMultiplier(ad, this.al0));
                    break;
                case "IndicatorSmoothingPeriod":
                    this.apt((ad, ae) => this.ajm.setSmoothingPeriod(ad, this.amz));
                    break;
                case "IndicatorShortPeriod":
                    this.apt((ad, ae) => this.ajm.setShortPeriod(ad, this.amx));
                    break;
                case "IndicatorLongPeriod":
                    this.apt((ad, ae) => this.ajm.setLongPeriod(ad, this.amv));
                    break;
                case "IndicatorSignalPeriod":
                    this.apt((ad, ae) => this.ajm.setSignalPeriod(ad, this.amy));
                    break;
                case "RangeSelectorOptions":
                    let ad = typeCast(FinancialChartRangeSelectorOptionCollection.$, b);
                    if (ad != null) {
                        ad.collectionChanged = delegateRemove(ad.collectionChanged, runOn(this, this.ap4));
                    }
                    if (this.aiu != null) {
                        let ae = this.aiu;
                        ae.collectionChanged = delegateCombine(ae.collectionChanged, runOn(this, this.ap4));
                    }
                    this.aqq();
                    break;
                case "CustomIndicatorNames":
                    let af = typeCast(ObservableCollection$1.$.specialize(String_$type), b);
                    if (af != null) {
                        af.collectionChanged = delegateRemove(af.collectionChanged, runOn(this, this.ap0));
                    }
                    if (this.customIndicatorNames != null) {
                        let ag = this.customIndicatorNames;
                        ag.collectionChanged = delegateCombine(ag.collectionChanged, runOn(this, this.ap0));
                    }
                    this.aq0();
                    break;
                case "Legend":
                    if (this.zoomSliderChart != null) {
                        this.zoomSliderChart.legend = null;
                    }
                    break;
                case "Brushes":
                    this.apv((ah, ai) => ah.vk = this.z != null ? ArrayExtension.getModulus$1(Brush.$, this.z, ai) : null, true);
                    break;
                case "Outlines":
                    this.apv((ah, ai) => ah.v0 = this.ad != null ? ArrayExtension.getModulus$1(Brush.$, this.ad, ai) : null, true);
                    break;
                case "XAxisLabelVisibility":
                    if (this.ahv == 0 && this.zoomSliderXAxis != null) {
                        this.af5(this.zoomSliderXAxis, (ah) => ah.visibility = 1);
                    }
                    this.app();
                    break;
                case "YAxisLabelVisibility":
                    if (this.ahw != 0 || this.zoomSliderAxis == null) {
                        break;
                    }
                    this.af5(this.zoomSliderAxis, (ah) => ah.visibility = 1);
                    break;
                case "ZoomSliderXAxisMajorStroke":
                    this.zoomSliderXAxis.jz = this.arb;
                    break;
                case "ZoomSliderXAxisMajorStrokeThickness":
                    this.zoomSliderXAxis.et = this.amh;
                    break;
                case "FinancialChartLegend":
                case "IsLegendVisible":
                    let ah = this.aks && this.legend == null;
                    {
                        let ai = (aj, ak) => {
                            if (aj.isUsableInLegend) {
                                aj.legend = ah ? this.ajg : null;
                            }
                        };
                        this.apv(ai, false);
                        this.apu(ai);
                    }
                    break;
                case "ZoomSliderAxis":
                    let aj = typeCast(Axis.$, b);
                    if (aj != null && this.zoomSliderChart != null) {
                        this.zoomSliderChart.axes.remove(aj);
                    }
                    if (this.zoomSliderAxis != null) {
                        if (this.zoomSliderChart != null) {
                            this.zoomSliderChart.axes.add(this.zoomSliderAxis);
                            this.aqn();
                            this.zoomSliderXAxis.itemsSource = this.xAxis.itemsSource;
                        }
                        if (this.gk) {
                            this.af9(this.zoomSliderAxis);
                        }
                        this.af5(this.zoomSliderAxis, (ak) => ak.visibility = 1);
                    }
                    break;
                case "XAxisMinimumValue":
                    this.agb((ak) => {
                        let al = typeCast(ITimeRangeSelectorAxis_$type, ak);
                        if (al != null) {
                            al.minimumValue = this.ali;
                        }
                    });
                    break;
                case "XAxisMaximumValue":
                    this.agb((ak) => {
                        let al = typeCast(ITimeRangeSelectorAxis_$type, ak);
                        if (al != null) {
                            al.maximumValue = this.alh;
                        }
                    });
                    break;
                case FinancialChart.aow:
                    this.agc((ak) => ak.b1 = this.ak0, a);
                    break;
                case FinancialChart.ao7:
                    this.agg((ak) => ak.b1 = this.ak2);
                    break;
            }
        }
        get_cb() {
            return 1;
        }
        get cb() {
            return this.get_cb();
        }
        get ak3() {
            return this.akl;
        }
        set ak3(a) {
            let b = this.ak3;
            if (a != b) {
                this.akl = a;
                this.wd("YAxisIsLogarithmic", b, this.ak3);
            }
        }
        get am1() {
            return this.amt;
        }
        set am1(a) {
            let b = this.am1;
            if (a != b) {
                this.amt = a;
                this.wd("YAxisLogarithmBase", b, this.am1);
            }
        }
        get amd() {
            return this.alu;
        }
        set amd(a) {
            let b = this.amd;
            if (a != b) {
                this.alu = a;
                this.wd("YAxisInterval", b, this.amd);
            }
        }
        get amf() {
            return this.alw;
        }
        set amf(a) {
            let b = this.amf;
            if (a != b) {
                this.alw = a;
                this.wd("YAxisMinimumValue", b, this.amf);
            }
        }
        get ame() {
            return this.alv;
        }
        set ame(a) {
            let b = this.ame;
            if (a != b) {
                this.alv = a;
                this.wd("YAxisMaximumValue", b, this.ame);
            }
        }
        get amg() {
            return this.alx;
        }
        set amg(a) {
            let b = this.amg;
            if (a != b) {
                this.alx = a;
                this.wd("YAxisMinorInterval", b, this.amg);
            }
        }
        get amc() {
            return this.yAxis.l4;
        }
        get amb() {
            return this.yAxis.l3;
        }
        get ai3() {
            return this.ai1;
        }
        set ai3(a) {
            let b = this.ai3;
            if (a != b) {
                this.ai1 = a;
                this.wd("VolumeType", enumGetBox(FinancialChartVolumeType_$type, b), enumGetBox(FinancialChartVolumeType_$type, this.ai3));
            }
        }
        get ai5() {
            return this.ai4;
        }
        set ai5(a) {
            let b = this.ai5;
            if (a != b) {
                this.ai4 = a;
                this.wd("XAxisMode", enumGetBox(FinancialChartXAxisMode_$type, b), enumGetBox(FinancialChartXAxisMode_$type, this.ai5));
            }
        }
        get al6() {
            return this.alp;
        }
        set al6(a) {
            let b = this.al6;
            if (a != b) {
                this.alp = a;
                this.wd("XAxisZoomMaximumCategoryRange", b, this.al6);
            }
        }
        get al9() {
            return this.als;
        }
        set al9(a) {
            let b = this.al9;
            if (a != b) {
                this.als = a;
                this.wd("XAxisZoomToCategoryStart", b, this.al9);
            }
        }
        get al7() {
            return this.alq;
        }
        set al7(a) {
            let b = this.al7;
            if (a != b) {
                this.alq = a;
                this.wd("XAxisZoomMaximumItemSpan", b, this.al7);
            }
        }
        get al8() {
            return this.alr;
        }
        set al8(a) {
            let b = this.al8;
            if (a != b) {
                this.alr = a;
                this.wd("XAxisZoomToCategoryRange", b, this.al8);
            }
        }
        get ama() {
            return this.alt;
        }
        set ama(a) {
            let b = this.ama;
            if (a != b) {
                this.alt = a;
                this.wd("XAxisZoomToItemSpan", b, this.ama);
            }
        }
        get ai7() {
            return this.ai6;
        }
        set ai7(a) {
            let b = this.ai7;
            if (a != b) {
                this.ai6 = a;
                this.wd("YAxisMode", enumGetBox(FinancialChartYAxisMode_$type, b), enumGetBox(FinancialChartYAxisMode_$type, this.ai7));
            }
        }
        get akw() {
            return this.akg;
        }
        set akw(a) {
            let b = this.akw;
            if (a != b) {
                this.akg = a;
                this.wd("IsToolbarVisible", b, this.akw);
            }
        }
        get aiy() {
            return this.aix;
        }
        set aiy(a) {
            let b = this.aiy;
            if (a != b) {
                this.aix = a;
                this.wd("ChartType", enumGetBox(FinancialChartType_$type, b), enumGetBox(FinancialChartType_$type, this.aiy));
            }
        }
        get_agq() {
            return super.get_agq();
        }
        set_agq(a) {
            super.set_agq(a);
        }
        get akx() {
            return this.akh;
        }
        set akx(a) {
            let b = this.akx;
            if (a != b) {
                this.akh = a;
                this.wd("IsWindowSyncedToVisibleRange", b, this.akx);
            }
        }
        get ajc() {
            return this.ajb;
        }
        set ajc(a) {
            let b = this.ajc;
            if (a != b) {
                this.ajb = a;
                this.wd("IndicatorTypes", b, this.ajc);
            }
        }
        get aje() {
            return this.ajd;
        }
        set aje(a) {
            let b = this.aje;
            if (a != b) {
                this.ajd = a;
                this.wd("OverlayTypes", b, this.aje);
            }
        }
        get indicatorCharts() {
            return this.ak8;
        }
        set indicatorCharts(a) {
            let b = this.indicatorCharts;
            if (a != b) {
                this.ak8 = a;
                this.wd("IndicatorCharts", b, this.indicatorCharts);
            }
        }
        get ak1() {
            return this.akj;
        }
        set ak1(a) {
            let b = this.ak1;
            if (a != b) {
                this.akj = a;
                this.wd("YAxisAbbreviateLargeNumbers", b, this.ak1);
            }
        }
        get_ka() {
            return super.get_ka();
        }
        set_ka(a) {
            super.set_ka(a);
        }
        get ak0() {
            return this.aki;
        }
        set ak0(a) {
            let b = this.ak0;
            if (a != b) {
                this.aki = a;
                this.wd(FinancialChart.aow, b, this.ak0);
            }
        }
        get ak2() {
            return this.akk;
        }
        set ak2(a) {
            let b = this.ak2;
            if (a != b) {
                this.akk = a;
                this.wd(FinancialChart.ao7, b, this.ak2);
            }
        }
        get zoomSliderChart() {
            return this.aka;
        }
        set zoomSliderChart(a) {
            let b = this.zoomSliderChart;
            if (a != b) {
                this.aka = a;
                this.wd("ZoomSliderChart", b, this.zoomSliderChart);
            }
        }
        get zoomSliderAxis() {
            return this.ajv;
        }
        set zoomSliderAxis(a) {
            let b = this.zoomSliderAxis;
            if (a != b) {
                this.ajv = a;
                this.wd("ZoomSliderAxis", b, this.zoomSliderAxis);
            }
        }
        get zoomSliderXAxis() {
            return this.aig;
        }
        set zoomSliderXAxis(a) {
            let b = this.zoomSliderXAxis;
            if (a != b) {
                this.aig = a;
                this.wd("ZoomSliderXAxis", b, this.zoomSliderXAxis);
            }
        }
        get aja() {
            return this.ai8;
        }
        set aja(a) {
            let b = this.aja;
            if (a != b) {
                this.ai8 = a;
                this.wd("ZoomSliderType", enumGetBox(FinancialChartZoomSliderType_$type, b), enumGetBox(FinancialChartZoomSliderType_$type, this.aja));
            }
        }
        get ah7() {
            return this.ahz;
        }
        set ah7(a) {
            let b = this.ah7;
            if (a != b) {
                this.ahz = a;
                this.wd("NegativeBrushes", b, this.ah7);
            }
        }
        get ah8() {
            return this.ah0;
        }
        set ah8(a) {
            let b = this.ah8;
            if (a != b) {
                this.ah0 = a;
                this.wd("NegativeOutlines", b, this.ah8);
            }
        }
        get ah9() {
            return this.ah1;
        }
        set ah9(a) {
            let b = this.ah9;
            if (a != b) {
                this.ah1 = a;
                this.wd("OverlayBrushes", b, this.ah9);
            }
        }
        get aia() {
            return this.ah2;
        }
        set aia(a) {
            let b = this.aia;
            if (a != b) {
                this.ah2 = a;
                this.wd("OverlayOutlines", b, this.aia);
            }
        }
        get aic() {
            return this.ah4;
        }
        set aic(a) {
            let b = this.aic;
            if (a != b) {
                this.ah4 = a;
                this.wd("VolumeOutlines", b, this.aic);
            }
        }
        get aib() {
            return this.ah3;
        }
        set aib(a) {
            let b = this.aib;
            if (a != b) {
                this.ah3 = a;
                this.wd("VolumeBrushes", b, this.aib);
            }
        }
        get ah6() {
            return this.ahy;
        }
        set ah6(a) {
            let b = this.ah6;
            if (a != b) {
                this.ahy = a;
                this.wd("IndicatorNegativeBrushes", b, this.ah6);
            }
        }
        get ah5() {
            return this.ahx;
        }
        set ah5(a) {
            let b = this.ah5;
            if (a != b) {
                this.ahx = a;
                this.wd("IndicatorBrushes", b, this.ah5);
            }
        }
        get al5() {
            return this.alo;
        }
        set al5(a) {
            let b = this.al5;
            if (a != b) {
                this.alo = a;
                this.wd("VolumeThickness", b, this.al5);
            }
        }
        get al3() {
            return this.alm;
        }
        set al3(a) {
            let b = this.al3;
            if (a != b) {
                this.alm = a;
                this.wd("OverlayThickness", b, this.al3);
            }
        }
        get al2() {
            return this.all;
        }
        set al2(a) {
            let b = this.al2;
            if (a != b) {
                this.all = a;
                this.wd("OverlayMultiplier", b, this.al2);
            }
        }
        get al1() {
            return this.alk;
        }
        set al1(a) {
            let b = this.al1;
            if (a != b) {
                this.alk = a;
                this.wd("IndicatorThickness", b, this.al1);
            }
        }
        get ajo() {
            return this.ajn;
        }
        set ajo(a) {
            let b = this.ajo;
            if (a != b) {
                this.ajn = a;
                this.wd("IndicatorDisplayTypes", b, this.ajo);
            }
        }
        get amw() {
            return this.amp;
        }
        set amw(a) {
            let b = this.amw;
            if (a != b) {
                this.amp = a;
                this.wd("IndicatorPeriod", b, this.amw);
            }
        }
        get al0() {
            return this.alj;
        }
        set al0(a) {
            let b = this.al0;
            if (a != b) {
                this.alj = a;
                this.wd("IndicatorMultiplier", b, this.al0);
            }
        }
        get amz() {
            return this.ams;
        }
        set amz(a) {
            let b = this.amz;
            if (a != b) {
                this.ams = a;
                this.wd("IndicatorSmoothingPeriod", b, this.amz);
            }
        }
        get amx() {
            return this.amq;
        }
        set amx(a) {
            let b = this.amx;
            if (a != b) {
                this.amq = a;
                this.wd("IndicatorShortPeriod", b, this.amx);
            }
        }
        get amv() {
            return this.amo;
        }
        set amv(a) {
            let b = this.amv;
            if (a != b) {
                this.amo = a;
                this.wd("IndicatorLongPeriod", b, this.amv);
            }
        }
        get amy() {
            return this.amr;
        }
        set amy(a) {
            let b = this.amy;
            if (a != b) {
                this.amr = a;
                this.wd("IndicatorSignalPeriod", b, this.amy);
            }
        }
        get aiu() {
            return this.ais;
        }
        set aiu(a) {
            let b = this.aiu;
            if (a != b) {
                this.ais = a;
                this.wd("RangeSelectorOptions", b, this.aiu);
            }
        }
        get customIndicatorNames() {
            return this.aio;
        }
        set customIndicatorNames(a) {
            let b = this.aio;
            if (a != b) {
                this.aio = a;
                this.wd("CustomIndicatorNames", b, this.customIndicatorNames);
            }
        }
        get_he() {
            return super.get_he();
        }
        set_he(a) {
            super.set_he(a);
        }
        get arb() {
            return this.ara;
        }
        set arb(a) {
            let b = this.arb;
            if (a != b) {
                this.ara = a;
                this.wd("ZoomSliderXAxisMajorStroke", b, this.arb);
            }
        }
        get amh() {
            return this.aly;
        }
        set amh(a) {
            let b = this.amh;
            if (a != b) {
                this.aly = a;
                this.wd("ZoomSliderXAxisMajorStrokeThickness", b, this.amh);
            }
        }
        get aks() {
            return this.akf;
        }
        set aks(a) {
            let b = this.aks;
            if (a != b) {
                this.akf = a;
                this.wd("IsLegendVisible", b, this.aks);
            }
        }
        get ajg() {
            return this.ajf;
        }
        set ajg(a) {
            let b = this.ajg;
            if (a != b) {
                this.ajf = a;
                this.wd("FinancialChartLegend", b, this.ajg);
            }
        }
        get xAxis() {
            return this.aif;
        }
        set xAxis(a) {
            let b = this.xAxis;
            if (a != b) {
                this.aif = a;
                this.wd("XAxis", b, this.xAxis);
            }
        }
        get yAxis() {
            return this.aju;
        }
        set yAxis(a) {
            let b = this.yAxis;
            if (a != b) {
                this.aju = a;
                this.wd("YAxis", b, this.yAxis);
            }
        }
        get volumeAxis() {
            return this.ajt;
        }
        set volumeAxis(a) {
            let b = this.volumeAxis;
            if (a != b) {
                this.ajt = a;
                this.wd("VolumeAxis", b, this.volumeAxis);
            }
        }
        get volumeXAxis() {
            return this.aie;
        }
        set volumeXAxis(a) {
            let b = this.volumeXAxis;
            if (a != b) {
                this.aie = a;
                this.wd("VolumeXAxis", b, this.volumeXAxis);
            }
        }
        get indicatorAxis() {
            return this.ajs;
        }
        set indicatorAxis(a) {
            let b = this.indicatorAxis;
            if (a != b) {
                this.ajs = a;
                this.wd("IndicatorAxis", b, this.indicatorAxis);
            }
        }
        get indicatorXAxis() {
            return this.aid;
        }
        set indicatorXAxis(a) {
            let b = this.indicatorXAxis;
            if (a != b) {
                this.aid = a;
                this.wd("IndicatorXAxis", b, this.indicatorXAxis);
            }
        }
        get ala() {
            return this.ak7;
        }
        set ala(a) {
            let b = this.ala;
            if (a != b) {
                this.ak7 = a;
                this.wd("IndicatorAxes", b, this.ala);
            }
        }
        get alc() {
            return this.ak9;
        }
        set alc(a) {
            let b = this.alc;
            if (a != b) {
                this.ak9 = a;
                this.wd("IndicatorXAxes", b, this.alc);
            }
        }
        get ali() {
            return this.alg;
        }
        set ali(a) {
            let b = this.ali;
            if (+a != +b) {
                this.alg = a;
                this.wd("XAxisMinimumValue", b, this.ali);
            }
        }
        get alh() {
            return this.alf;
        }
        set alh(a) {
            let b = this.alh;
            if (+a != +b) {
                this.alf = a;
                this.wd("XAxisMaximumValue", b, this.alh);
            }
        }
        get xAxisBreaks() {
            return this.ald;
        }
    }
    FinancialChart.$t = markType(FinancialChart, 'FinancialChart', XYChart.$);
    FinancialChart.am0 = 0;
    FinancialChart.aow = "XAxisEnhancedIntervalPreferMoreCategoryLabels";
    FinancialChart.ao7 = "YAxisEnhancedIntervalPreferMoreCategoryLabels";
    return FinancialChart;
})();
/**
 * @hidden
 */
export let FinancialChartToolbar = /*@__PURE__*/ (() => {
    class FinancialChartToolbar extends TemplatedHtmlControl {
        constructor(a, b) {
            super("financialChartToolbar", b, "");
            this.o = null;
            this.r = null;
            this.z = null;
            this.p = null;
            this.w = null;
            this.aq = dateMaxValue();
            this.ap = dateMinValue();
            this.ao = dateMaxValue();
            this.an = dateMinValue();
            this.rangeChanged = null;
            this.chartTypeChanged = null;
            this.trendLineTypeChanged = null;
            this.volumeTypeChanged = null;
            this.indicatorTypesChanged = null;
            this.overlayTypesChanged = null;
            this.x = 0;
            this.ah = 0;
            this.ab = 0;
            this.ad = null;
            this.af = null;
            this.t = null;
            this.ak = false;
            this.o = a;
            this.w = new FinancialChartToolbarViewModel();
            this.s = new FinancialChartRangeSelector(a != null ? a.anc : null);
            this.aa = new FinancialChartTypePicker(a != null ? a.am9 : null);
            this.q = new FinancialChartIndicatorMenu(1, a != null ? a.ana : null);
        }
        bg(a) {
            let b = a.querySelectorAll(".financialChartToolbarArea");
            if (b != null && b.length > 0) {
                this.g = b[0];
                if (!this.al) {
                    this.g.hide();
                }
            }
            let c = a.querySelectorAll(".financialChartIndicatorMenu");
            if (c != null && c.length > 0) {
                this.q.g = c[0];
            }
            let d = a.querySelectorAll(".financialChartRangeSelector");
            if (d != null && d.length > 0) {
                this.s.g = d[0];
            }
            let e = a.querySelectorAll(".financialChartTypePicker");
            if (e != null && e.length > 0) {
                this.aa.g = e[0];
            }
        }
        bl(a) {
            this.q.u(a);
            this.aa.u(a);
        }
        get s() {
            return this.r;
        }
        set s(a) {
            let b = this.s;
            if (a != b) {
                this.r = a;
                this.bm("RangeSelector", b, this.s);
            }
        }
        get aa() {
            return this.z;
        }
        set aa(a) {
            let b = this.aa;
            if (a != b) {
                this.z = a;
                this.bm("ChartTypePicker", b, this.aa);
            }
        }
        get q() {
            return this.p;
        }
        set q(a) {
            let b = this.q;
            if (a != b) {
                this.p = a;
                this.bm("IndicatorMenu", b, this.q);
            }
        }
        bm(a, b, c) {
            switch (a) {
                case "RangeStart":
                    if (this.s != null) {
                        this.s.t = this.as;
                    }
                    break;
                case "RangeEnd":
                    if (this.s != null) {
                        this.s.s = this.ar;
                    }
                    break;
                case "SelectionStart":
                    if (this.s != null) {
                        this.s.v = this.au;
                    }
                    break;
                case "SelectionEnd":
                    if (this.s != null) {
                        this.s.u = this.at;
                    }
                    break;
                case "RangeSelector":
                    let d = b;
                    if (d != null) {
                        d.rangeChanged = delegateRemove(d.rangeChanged, runOn(this, this.bj));
                    }
                    if (this.s != null) {
                        this.s.t = this.as;
                        this.s.s = this.ar;
                        this.s.o = this.u;
                        this.s.v = this.au;
                        this.s.u = this.at;
                        let e = this.s;
                        e.rangeChanged = delegateCombine(e.rangeChanged, runOn(this, this.bj));
                    }
                    break;
                case "ChartTypePicker":
                    let f = b;
                    if (f != null) {
                        f.selectionChanged = delegateRemove(f.selectionChanged, runOn(this, this.bi));
                    }
                    if (this.aa != null) {
                        this.aa.w = this.y;
                        let g = this.aa;
                        g.selectionChanged = delegateCombine(g.selectionChanged, runOn(this, this.bi));
                    }
                    break;
                case "ChartType":
                    if (this.aa != null) {
                        this.aa.w = this.y;
                    }
                    break;
                case "RangeSelectorOptions":
                    if (this.s != null) {
                        this.s.o = this.u;
                    }
                    break;
                case "IsToolbarVisible":
                    if (this.g == null) {
                        break;
                    }
                    if (this.al) {
                        this.g.show();
                    }
                    else {
                        this.g.hide();
                    }
                    break;
                case "IndicatorMenu":
                    let h = typeCast(FinancialChartIndicatorMenu.$, b);
                    if (h != null) {
                        h.selectionChanged = delegateRemove(h.selectionChanged, runOn(this, this.bh));
                    }
                    if (this.q != null) {
                        let i = this.q;
                        i.selectionChanged = delegateCombine(i.selectionChanged, runOn(this, this.bh));
                    }
                    break;
                case "IndicatorTypes":
                    if (this.indicatorTypesChanged != null) {
                        this.indicatorTypesChanged(this, EventArgs.empty);
                    }
                    break;
                case "OverlayTypes":
                    if (this.overlayTypesChanged != null) {
                        this.overlayTypesChanged(this, EventArgs.empty);
                    }
                    break;
                case "TrendLineType":
                    if (this.trendLineTypeChanged != null) {
                        this.trendLineTypeChanged(this, EventArgs.empty);
                    }
                    break;
                case "VolumeType":
                    if (this.volumeTypeChanged != null) {
                        this.volumeTypeChanged(this, EventArgs.empty);
                    }
                    break;
            }
        }
        bh(a, b) {
            this.ag = this.q.z;
            this.ae = this.q.y;
            this.ai = this.q.aa;
            this.ac = this.q.x;
        }
        bi(a, b) {
            this.y = this.aa.w;
            if (this.chartTypeChanged != null) {
                this.chartTypeChanged(this, b);
            }
        }
        bj(a, b) {
            this.au = this.s.v;
            this.at = this.s.u;
            if (this.rangeChanged != null) {
                this.rangeChanged(this, b);
            }
        }
        v() {
            let a = new FinancialChartToolbarContext();
            a.container = this.d;
            a.vm = this.w;
            a.vm.financialChartIndicatorMenu = ((() => {
                let $ret = new FinancialChartIndicatorMenuContext();
                $ret.vm = this.q.p;
                return $ret;
            })());
            a.vm.financialChartTypePicker = ((() => {
                let $ret = new FinancialChartTypePickerContext();
                $ret.vm = this.aa.p;
                return $ret;
            })());
            a.vm.financialChartRangeSelector = ((() => {
                let $ret = new FinancialChartRangeSelectorContext();
                $ret.vm = this.s.q;
                return $ret;
            })());
            return a;
        }
        l(a) {
            super.l(a);
            if (a == null) {
                return;
            }
            this.s.l(a);
            this.aa.l(a);
            this.q.l(a);
            this.bk();
        }
        bk() {
        }
        get au() {
            return this.aq;
        }
        set au(a) {
            let b = this.au;
            if (+a != +b) {
                this.aq = a;
                this.bm("SelectionStart", b, this.au);
            }
        }
        get at() {
            return this.ap;
        }
        set at(a) {
            let b = this.at;
            if (+a != +b) {
                this.ap = a;
                this.bm("SelectionEnd", b, this.at);
            }
        }
        get as() {
            return this.ao;
        }
        set as(a) {
            let b = this.as;
            if (+a != +b) {
                this.ao = a;
                this.bm("RangeStart", b, this.as);
            }
        }
        get ar() {
            return this.an;
        }
        set ar(a) {
            let b = this.ar;
            if (+a != +b) {
                this.an = a;
                this.bm("RangeEnd", b, this.ar);
            }
        }
        bn() {
            if (this.s != null) {
                this.s.ab();
            }
        }
        get y() {
            return this.x;
        }
        set y(a) {
            let b = this.y;
            if (a != b) {
                this.x = a;
                this.bm("ChartType", enumGetBox(FinancialChartType_$type, b), enumGetBox(FinancialChartType_$type, this.y));
            }
        }
        get ai() {
            return this.ah;
        }
        set ai(a) {
            let b = this.ai;
            if (a != b) {
                this.ah = a;
                this.bm("TrendLineType", enumGetBox(TrendLineType_$type, b), enumGetBox(TrendLineType_$type, this.ai));
            }
        }
        get ac() {
            return this.ab;
        }
        set ac(a) {
            let b = this.ac;
            if (a != b) {
                this.ab = a;
                this.bm("VolumeType", enumGetBox(FinancialChartVolumeType_$type, b), enumGetBox(FinancialChartVolumeType_$type, this.ac));
            }
        }
        get ae() {
            return this.ad;
        }
        set ae(a) {
            let b = this.ae;
            if (!FinancialChartToolbar.am(b, a)) {
                this.ad = a;
                this.bm("IndicatorTypes", b, this.ae);
            }
        }
        get ag() {
            return this.af;
        }
        set ag(a) {
            let b = this.ag;
            if (!FinancialChartToolbar.am(b, a)) {
                this.af = a;
                this.bm("OverlayTypes", b, this.ag);
            }
        }
        static am(a, b) {
            if (a == b) {
                return true;
            }
            if ((a == null && b != null) || (a != null && b == null)) {
                return false;
            }
            if (a.count != b.count) {
                return false;
            }
            for (let c of fromEn(a)) {
                if (!b.contains(c)) {
                    return false;
                }
            }
            return true;
        }
        aj() {
            return ((() => {
                let $ret = new FinancialChartToolbarVisualData();
                $ret.rangeSelector = this.s == null ? null : this.s.r();
                return $ret;
            })());
        }
        get u() {
            return this.t;
        }
        set u(a) {
            let b = this.u;
            if (a != b) {
                this.t = a;
                this.bm("RangeSelectorOptions", b, this.u);
            }
        }
        get al() {
            return this.ak;
        }
        set al(a) {
            let b = this.al;
            if (a != b) {
                this.ak = a;
                this.bm("IsToolbarVisible", b, this.al);
            }
        }
    }
    FinancialChartToolbar.$t = markType(FinancialChartToolbar, 'FinancialChartToolbar', TemplatedHtmlControl.$);
    return FinancialChartToolbar;
})();
/**
 * @hidden
 */
export let FinancialChartRangeSelector = /*@__PURE__*/ (() => {
    class FinancialChartRangeSelector extends TemplatedHtmlControl {
        constructor(a) {
            super("financialChartRangeSelector", a, "");
            this.q = null;
            this.rangeChanged = null;
            this.p = null;
            this.p = new FinancialChartRangeSelectorView();
            this.q = new FinancialChartRangeSelectorViewModel();
            this.q.onRangeChanged = runOn(this, this.z);
            this.p.c = this.q;
        }
        get v() {
            return this.q.selectionStart;
        }
        set v(a) {
            this.q.selectionStart = a;
        }
        get u() {
            return this.q.selectionEnd;
        }
        set u(a) {
            this.q.selectionEnd = a;
        }
        get t() {
            return this.q.rangeStart;
        }
        set t(a) {
            this.q.rangeStart = a;
        }
        get s() {
            return this.q.rangeEnd;
        }
        set s(a) {
            this.q.rangeEnd = a;
        }
        ab() {
            if (this.q.onPropertiesChanged()) {
                this.p.g(this.q);
            }
        }
        l(a) {
            super.l(a);
            this.p.f(this.d, this.q);
        }
        z() {
            if (this.rangeChanged != null) {
                this.rangeChanged(this, EventArgs.empty);
            }
        }
        r() {
            return this.p.d(this.g);
        }
        get o() {
            return this.q.options;
        }
        set o(a) {
            let b = !FinancialChartToolbar.am(this.q.options, a);
            if (b) {
                this.q.options = a;
                this.aa();
            }
        }
        aa() {
            let a = false;
            if (this.q != null) {
                a = this.q.p();
            }
            if (this.p != null) {
                this.p.i(this.o);
                if (a) {
                    if (this.q.notifyChanged != null) {
                        this.q.notifyChanged();
                    }
                }
            }
        }
    }
    FinancialChartRangeSelector.$t = markType(FinancialChartRangeSelector, 'FinancialChartRangeSelector', TemplatedHtmlControl.$);
    FinancialChartRangeSelector.x = 0;
    return FinancialChartRangeSelector;
})();
