import { IgCollection } from "igniteui-angular-core";
import { SyncableObservableCollection$2 } from "igniteui-angular-core";
import { TrendLineType_$type } from "igniteui-angular-core";
import { ensureEnum } from "igniteui-angular-core";
export class IgxTrendLineTypeCollection extends IgCollection {
    constructor(list) {
        super();
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _ensureOuter(item) {
        return ensureEnum(TrendLineType_$type, item);
    }
    _createInnerColl() {
        let coll = new SyncableObservableCollection$2(TrendLineType_$type, TrendLineType_$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext;
        };
        coll.createFrom = (int) => {
            return int;
        };
        return coll;
    }
}
