/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { XYChart } from "./XYChart";
import { typeCast, runOn, delegateCombine, enumGetBox, markType, TypeRegistrar, getInstanceType } from "igniteui-angular-core";
import { CategoryChartType_$type } from "./CategoryChartType";
import { CategorySeriesMarkerCollisionAvoidance_$type } from "./CategorySeriesMarkerCollisionAvoidance";
import { CategoryTransitionInMode_$type } from "./CategoryTransitionInMode";
import { TransitionInSpeedType_$type } from "./TransitionInSpeedType";
import { AutoMarginsAndAngleUpdateMode_$type } from "./AutoMarginsAndAngleUpdateMode";
import { AxisRangeBufferMode_$type } from "./AxisRangeBufferMode";
import { CategoryXAxis } from "./CategoryXAxis";
import { List$1 } from "igniteui-angular-core";
import { DataSeriesType_$type } from "igniteui-angular-core";
import { NumericYAxis } from "./NumericYAxis";
import { IDataSeriesAdapterRule_$type } from "igniteui-angular-core";
import { SimpleCategorySeriesRule } from "igniteui-angular-core";
import { SubCollectionsRule } from "igniteui-angular-core";
import { DVContainer } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { AxisDefaults } from "./AxisDefaults";
import { Defaults } from "./Defaults";
import { Series } from "./Series";
import { HorizontalAnchoredCategorySeries } from "./HorizontalAnchoredCategorySeries";
import { ArrayExtension } from "igniteui-angular-core";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { DeviceUtils } from "igniteui-angular-core";
import { CategoryChartMockDataGenerator } from "./CategoryChartMockDataGenerator";
import { stringIsNullOrEmpty } from "igniteui-angular-core";
/**
 * @hidden
 */
var CategoryChart = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CategoryChart, _super);
    function CategoryChart() {
        var _this = _super.call(this) || this;
        _this.aki = 1000;
        _this.akj = 1000;
        _this.ail = null;
        _this.aim = null;
        _this.ah5 = 9;
        _this.ah7 = 1;
        _this.air = false;
        _this.ais = true;
        _this.ah9 = 0;
        _this.aij = 0;
        _this.ajf = 0;
        _this.aji = 0;
        _this.aje = 0;
        _this.ajh = 0;
        _this.ajg = 1;
        _this.ajj = 0;
        _this.ajp = NaN;
        _this.ah1 = 1;
        _this.ait = true;
        _this.aiu = true;
        _this.ajc = DeviceUtils.g(2);
        _this.ajd = DeviceUtils.g(60);
        _this.aiy = true;
        _this.aiv = true;
        _this.aix = false;
        _this.ah3 = 0;
        _this.aiz = false;
        _this.akk = 10;
        _this.ajr = NaN;
        _this.ajq = NaN;
        _this.ajs = 0;
        _this.ahx = null;
        _this.ahy = null;
        _this.aiw = true;
        _this.ajk = 3;
        _this.ajl = NaN;
        _this.ajm = NaN;
        _this.ajn = NaN;
        _this.ajo = NaN;
        _this.aip = false;
        _this.aiq = false;
        _this.ajb = null;
        DVContainer.instance.registerIfLoaded("CategoryChartToolbarFactoryManager");
        _this.u2();
        return _this;
    }
    CategoryChart.prototype.vm = function () {
        _super.prototype.vm.call(this);
        if (this.dataChart == null) {
            return;
        }
        var a = this.dataChart.c9.j.e();
        this.ahz = a.d;
        this.ah0 = a.e;
        if (this.ag9 == null) {
            this.ag9 = a.k;
        }
        if (this.ahg == null) {
            this.ahg = a.k;
        }
        this.ac4 = 0;
        this.ahh = AxisDefaults.axis_MajorBrush;
        this.ahk = null;
        this.ahd = AxisDefaults.axis_LineBrush;
        this.aha = null;
        this.acl = AxisDefaults.categoryAxis_TickLength;
        this.ahe = AxisDefaults.axis_TickBrush;
        this.acm = AxisDefaults.axis_TickStroke;
        this.crosshairsAnnotationEnabled = true;
        this.gq = true;
        this.crosshairsDisplayMode = 0;
        this.jq = Defaults.crosshairLineThickness;
        this.yy = Defaults.crosshairLineBrush;
        this.yt = Defaults.crosshairXAxisAnnotationBackground;
        this.yu = Defaults.crosshairXAxisAnnotationTextColor;
        this.ai3 = true;
    };
    CategoryChart.prototype.vo = function (a, b) {
        _super.prototype.vo.call(this, a, b);
        a.kf = this.akl;
        a.kg = this.akm;
        a.df = this.ain;
        a.dg = this.aio;
    };
    CategoryChart.prototype.wh = function (a, b, c) {
        var _this = this;
        _super.prototype.wh.call(this, a, b, c);
        switch (a) {
            case "TransitionInDuration":
                this.vb(function (d) { return d.kf = _this.akl; });
                break;
            case "TransitionOutDuration":
                this.vb(function (d) { return d.kg = _this.akm; });
                break;
            case "TransitionInEasingFunction":
                this.vb(function (d) { return d.df = _this.ain; });
                break;
            case "TransitionOutEasingFunction":
                this.vb(function (d) { return d.dg = _this.aio; });
                break;
        }
    };
    Object.defineProperty(CategoryChart.prototype, "akl", {
        get: function () {
            return this.aki;
        },
        set: function (a) {
            var b = this.akl;
            if (a != b) {
                this.aki = a;
                this.wd("TransitionInDuration", b, this.akl);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "akm", {
        get: function () {
            return this.akj;
        },
        set: function (a) {
            var b = this.akm;
            if (a != b) {
                this.akj = a;
                this.wd("TransitionOutDuration", b, this.akm);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "ain", {
        get: function () {
            return this.ail;
        },
        set: function (a) {
            var b = this.ain;
            if (a != b) {
                this.ail = a;
                this.wd("TransitionInEasingFunction", b, this.ain);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "aio", {
        get: function () {
            return this.aim;
        },
        set: function (a) {
            var b = this.aio;
            if (a != b) {
                this.aim = a;
                this.wd("TransitionOutEasingFunction", b, this.aio);
            }
        },
        enumerable: false,
        configurable: true
    });
    CategoryChart.prototype.aks = function () {
        var cvd_ = this.l5();
        cvd_.scaleByViewport();
        return (cvd_.serialize());
    };
    CategoryChart.prototype.vh = function (a, b) {
        _super.prototype.vh.call(this, a, b);
        a.ej = this.gj;
        a.x1 = this.ai4;
        a.x4 = this.ai5;
        a.yr = this.ajt;
        a.ys = this.aju;
        a.w6 = this.ah2;
    };
    CategoryChart.prototype.vn = function (a, b) {
        _super.prototype.vn.call(this, a, b);
        var c = typeCast(HorizontalAnchoredCategorySeries.$, a);
        if (c == null) {
            return;
        }
        c.aa1 = this.ah8;
        c.zq = this.ai3;
        c.za = this.aia;
        c.c6 = this.aik;
        c.trendLineBrush = ArrayExtension.getModulus$1(Brush.$, this.af, b);
        c.trendLineType = this.ec;
        c.trendLineThickness = this.km;
        c.xf = this.c2(a, b);
        if (a.fn) {
            a.r7(ArrayExtension.getModulus$1(Brush.$, this.ahz, b), ArrayExtension.getModulus$1(Brush.$, this.ah0, b));
        }
    };
    CategoryChart.prototype.aib = function () {
        return new CategoryXAxis();
    };
    CategoryChart.prototype.aif = function () {
        return new NumericYAxis();
    };
    CategoryChart.prototype.ux = function () {
        this.xAxis = this.aib();
        this.xAxis.name = "xAxis";
        var a = this.xAxis;
        a.propertyChanged = delegateCombine(a.propertyChanged, runOn(this, this.alw));
        this.yAxis = this.aif();
        this.yAxis.name = "yAxis";
        var b = this.yAxis;
        b.propertyChanged = delegateCombine(b.propertyChanged, runOn(this, this.alx));
        if (this.xAxis.az == null) {
            this.xAxis.az = new AxisLabelSettings();
        }
        if (this.yAxis.az == null) {
            this.yAxis.az = new AxisLabelSettings();
        }
    };
    CategoryChart.prototype.af9 = function (a) {
        _super.prototype.af9.call(this, a);
        a.lf = this.ai7;
        a.lj = this.ai9;
        a.b1 = this.ai8;
    };
    CategoryChart.prototype.af7 = function (a) {
        _super.prototype.af7.call(this, a);
        a.b1 = this.ai6;
        a.zoomMaximumCategoryRange = this.aj7;
        a.zoomToCategoryRange = this.aj9;
        a.zoomToCategoryStart = this.aka;
        a.zoomMaximumItemSpan = this.aj8;
        a.zoomToItemSpan = this.akb;
    };
    CategoryChart.prototype.get_cb = function () {
        return 0;
    };
    Object.defineProperty(CategoryChart.prototype, "cb", {
        get: function () {
            return this.get_cb();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "ah6", {
        get: function () {
            return this.ah5;
        },
        set: function (a) {
            if (a != this.ah5) {
                var b = this.ah6;
                this.ah5 = a;
                this.wd("ChartType", enumGetBox(CategoryChartType_$type, b), enumGetBox(CategoryChartType_$type, this.ah6));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "ah8", {
        get: function () {
            return this.ah7;
        },
        set: function (a) {
            var b = this.ah8;
            if (a != b) {
                this.ah7 = a;
                this.wd("MarkerCollisionAvoidance", enumGetBox(CategorySeriesMarkerCollisionAvoidance_$type, b), enumGetBox(CategorySeriesMarkerCollisionAvoidance_$type, this.ah8));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "ai2", {
        get: function () {
            return this.air;
        },
        set: function (a) {
            var b = this.ai2;
            if (a != b) {
                this.air = a;
                this.wd("IsSplineShapePartOfRange", b, this.ai2);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "ai3", {
        get: function () {
            return this.ais;
        },
        set: function (a) {
            var b = this.ai3;
            if (a != b) {
                this.ais = a;
                this.wd("IsTransitionInEnabled", b, this.ai3);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "aia", {
        get: function () {
            return this.ah9;
        },
        set: function (a) {
            var b = this.aia;
            if (a != b) {
                this.ah9 = a;
                this.wd("TransitionInMode", enumGetBox(CategoryTransitionInMode_$type, b), enumGetBox(CategoryTransitionInMode_$type, this.aia));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "aik", {
        get: function () {
            return this.aij;
        },
        set: function (a) {
            var b = this.aik;
            if (a != b) {
                this.aij = a;
                this.wd("TransitionInSpeedType", enumGetBox(TransitionInSpeedType_$type, b), enumGetBox(TransitionInSpeedType_$type, this.aik));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "aj2", {
        get: function () {
            return this.ajf;
        },
        set: function (a) {
            var b = this.aj2;
            if (a != b) {
                this.ajf = a;
                this.wd("XAxisInterval", b, this.aj2);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "aj5", {
        get: function () {
            return this.aji;
        },
        set: function (a) {
            var b = this.aj5;
            if (a != b) {
                this.aji = a;
                this.wd("XAxisMinorInterval", b, this.aj5);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "aj1", {
        get: function () {
            return this.aje;
        },
        set: function (a) {
            var b = this.aj1;
            if (a != b) {
                this.aje = a;
                this.wd("XAxisGap", b, this.aj1);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "aj4", {
        get: function () {
            return this.ajh;
        },
        set: function (a) {
            var b = this.aj4;
            if (a != b) {
                this.ajh = a;
                this.wd("XAxisMinimumGapSize", b, this.aj4);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "aj3", {
        get: function () {
            return this.ajg;
        },
        set: function (a) {
            var b = this.aj3;
            if (a != b) {
                this.ajg = a;
                this.wd("XAxisMaximumGap", b, this.aj3);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "aj6", {
        get: function () {
            return this.ajj;
        },
        set: function (a) {
            var b = this.aj6;
            if (a != b) {
                this.ajj = a;
                this.wd("XAxisOverlap", b, this.aj6);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "ake", {
        get: function () {
            return this.ajp;
        },
        set: function (a) {
            var b = this.ake;
            if (a != b) {
                this.ajp = a;
                this.wd("YAxisInterval", b, this.ake);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "ah2", {
        get: function () {
            return this.ah1;
        },
        set: function (a) {
            var b = this.ah2;
            if (a != b) {
                this.ah1 = a;
                this.wd("AutoMarginAndAngleUpdateMode", enumGetBox(AutoMarginsAndAngleUpdateMode_$type, b), enumGetBox(AutoMarginsAndAngleUpdateMode_$type, this.ah2));
            }
        },
        enumerable: false,
        configurable: true
    });
    CategoryChart.prototype.aly = function () {
        if (this.dataChart != null) {
            this.dataChart.aac();
        }
    };
    Object.defineProperty(CategoryChart.prototype, "ai4", {
        get: function () {
            return this.ait;
        },
        set: function (a) {
            var b = this.ai4;
            if (a != b) {
                this.ait = a;
                this.wd("ShouldAutoExpandMarginForInitialLabels", b, this.ai4);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "ai5", {
        get: function () {
            return this.aiu;
        },
        set: function (a) {
            var b = this.ai5;
            if (a != b) {
                this.aiu = a;
                this.wd(CategoryChart.ak1, b, this.ai5);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "ajt", {
        get: function () {
            return this.ajc;
        },
        set: function (a) {
            var b = this.ajt;
            if (a != b) {
                this.ajc = a;
                this.wd("AutoExpandMarginExtraPadding", b, this.ajt);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "aju", {
        get: function () {
            return this.ajd;
        },
        set: function (a) {
            var b = this.aju;
            if (a != b) {
                this.ajd = a;
                this.wd("AutoExpandMarginMaximumValue", b, this.aju);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "ai9", {
        get: function () {
            return this.aiy;
        },
        set: function (a) {
            var b = this.ai9;
            if (a != b) {
                this.aiy = a;
                this.wd("YAxisFavorLabellingScaleEnd", b, this.ai9);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "ai6", {
        get: function () {
            return this.aiv;
        },
        set: function (a) {
            var b = this.ai6;
            if (a != b) {
                this.aiv = a;
                this.wd(CategoryChart.ak8, b, this.ai6);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "ai8", {
        get: function () {
            return this.aix;
        },
        set: function (a) {
            var b = this.ai8;
            if (a != b) {
                this.aix = a;
                this.wd(CategoryChart.alm, b, this.ai8);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "ah4", {
        get: function () {
            return this.ah3;
        },
        set: function (a) {
            var b = this.ah4;
            if (a != b) {
                this.ah3 = a;
                this.wd("YAxisAutoRangeBufferMode", enumGetBox(AxisRangeBufferMode_$type, b), enumGetBox(AxisRangeBufferMode_$type, this.ah4));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "aja", {
        get: function () {
            return this.aiz;
        },
        set: function (a) {
            var b = this.aja;
            if (a != b) {
                this.aiz = a;
                this.wd("YAxisIsLogarithmic", b, this.aja);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "akn", {
        get: function () {
            return this.akk;
        },
        set: function (a) {
            var b = this.akn;
            if (a != b) {
                this.akk = a;
                this.wd("YAxisLogarithmBase", b, this.akn);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "akg", {
        get: function () {
            return this.ajr;
        },
        set: function (a) {
            var b = this.akg;
            if (a != b) {
                this.ajr = a;
                this.wd("YAxisMinimumValue", b, this.akg);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "akf", {
        get: function () {
            return this.ajq;
        },
        set: function (a) {
            var b = this.akf;
            if (a != b) {
                this.ajq = a;
                this.wd("YAxisMaximumValue", b, this.akf);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "akh", {
        get: function () {
            return this.ajs;
        },
        set: function (a) {
            var b = this.akh;
            if (a != b) {
                this.ajs = a;
                this.wd("YAxisMinorInterval", b, this.akh);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "aj0", {
        get: function () {
            return this.xAxis.m1;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "ajz", {
        get: function () {
            return this.xAxis.m0;
        },
        enumerable: false,
        configurable: true
    });
    CategoryChart.prototype.ajw = function () {
        return this.aj0;
    };
    CategoryChart.prototype.ajy = function () {
        return this.akd;
    };
    CategoryChart.prototype.ajv = function () {
        return this.ajz;
    };
    CategoryChart.prototype.ajx = function () {
        return this.akc;
    };
    Object.defineProperty(CategoryChart.prototype, "akd", {
        get: function () {
            return this.yAxis.l4;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "akc", {
        get: function () {
            return this.yAxis.l3;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "ahz", {
        get: function () {
            return this.ahx;
        },
        set: function (a) {
            var b = this.ahz;
            if (a != b) {
                this.ahx = a;
                this.wd("NegativeBrushes", b, this.ahz);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "ah0", {
        get: function () {
            return this.ahy;
        },
        set: function (a) {
            var b = this.ah0;
            if (a != b) {
                this.ahy = a;
                this.wd("NegativeOutlines", b, this.ah0);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "ai7", {
        get: function () {
            return this.aiw;
        },
        set: function (a) {
            var b = this.ai7;
            if (a != b) {
                this.aiw = a;
                this.wd("YAxisAbbreviateLargeNumbers", b, this.ai7);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "aj7", {
        get: function () {
            return this.ajk;
        },
        set: function (a) {
            var b = this.aj7;
            if (a != b) {
                this.ajk = a;
                this.wd("XAxisZoomMaximumCategoryRange", b, this.aj7);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "aj8", {
        get: function () {
            return this.ajl;
        },
        set: function (a) {
            var b = this.aj8;
            if (a != b) {
                this.ajl = a;
                this.wd("XAxisZoomMaximumItemSpan", b, this.aj8);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "aj9", {
        get: function () {
            return this.ajm;
        },
        set: function (a) {
            var b = this.aj9;
            if (a != b) {
                this.ajm = a;
                this.wd("XAxisZoomToCategoryRange", b, this.aj9);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "aka", {
        get: function () {
            return this.ajn;
        },
        set: function (a) {
            var b = this.aka;
            if (a != b) {
                this.ajn = a;
                this.wd("XAxisZoomToCategoryStart", b, this.aka);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "akb", {
        get: function () {
            return this.ajo;
        },
        set: function (a) {
            var b = this.akb;
            if (a != b) {
                this.ajo = a;
                this.wd("XAxisZoomToItemSpan", b, this.akb);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "ai0", {
        get: function () {
            return this.aip;
        },
        set: function (a) {
            var b = this.ai0;
            if (a != b) {
                this.aip = a;
                this.wd("IsCategoryHighlightingEnabled", b, this.ai0);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "ai1", {
        get: function () {
            return this.aiq;
        },
        set: function (a) {
            var b = this.ai1;
            if (a != b) {
                this.aiq = a;
                this.wd("IsItemHighlightingEnabled", b, this.ai1);
            }
        },
        enumerable: false,
        configurable: true
    });
    CategoryChart.prototype.get_h2 = function () {
        var a = new List$1(DataSeriesType_$type, 0);
        if (TypeRegistrar.isRegistered("AreaSeries")) {
            a.add(2);
        }
        if (TypeRegistrar.isRegistered("ColumnSeries")) {
            a.add(1);
        }
        if (TypeRegistrar.isRegistered("LineSeries")) {
            a.add(0);
        }
        if (TypeRegistrar.isRegistered("PointSeries")) {
            a.add(10);
        }
        if (TypeRegistrar.isRegistered("SplineSeries")) {
            a.add(6);
        }
        if (TypeRegistrar.isRegistered("SplineAreaSeries")) {
            a.add(7);
        }
        if (TypeRegistrar.isRegistered("StepAreaSeries")) {
            a.add(5);
        }
        if (TypeRegistrar.isRegistered("StepLineSeries")) {
            a.add(4);
        }
        if (TypeRegistrar.isRegistered("WaterfallSeries")) {
            a.add(8);
        }
        return a;
    };
    Object.defineProperty(CategoryChart.prototype, "h2", {
        get: function () {
            return this.get_h2();
        },
        enumerable: false,
        configurable: true
    });
    CategoryChart.prototype.h8 = function () {
        if (this.ajb == null) {
            this.ajb = CategoryChartMockDataGenerator.a();
        }
        return this.ajb;
    };
    CategoryChart.prototype.c1 = function (a) {
        if (a != null) {
            var b = _super.prototype.c1.call(this, a);
            if (b == 2) {
                if (a.fm && this.g1) {
                    return 13;
                }
            }
        }
        return _super.prototype.c1.call(this, a);
    };
    CategoryChart.prototype.c3 = function (a) {
        if (a != null) {
            var b = _super.prototype.c1.call(this, a);
            if (b == 2) {
                if (a.fm && this.g1) {
                    return 13;
                }
            }
        }
        return _super.prototype.c3.call(this, a);
    };
    CategoryChart.prototype.get_hk = function () {
        return true;
    };
    CategoryChart.prototype.alw = function (a, b) {
        switch (b.propertyName) {
            case "ActualMinimum":
                this.wv("XAxisActualMinimum");
                break;
            case "ActualMaximum":
                this.wv("XAxisActualMaximum");
                break;
        }
    };
    CategoryChart.prototype.alx = function (a, b) {
        switch (b.propertyName) {
            case "ActualMinimumValue":
                this.wv("YAxisActualMinimum");
                break;
            case "ActualMaximumValue":
                this.wv("YAxisActualMaximum");
                break;
        }
    };
    CategoryChart.prototype.xa = function () {
        _super.prototype.xa.call(this);
        this.xAxis.f2 = this.ade == null ? XYChart.adq(this.xAxis, this.bf.dataSeries) : this.ade;
        this.xAxis.itemsSource = this.dataChart != null && this.dataChart.series.count > 0 ? this.dataChart.series._inner[0].itemsSource : null;
        if (this.ai4) {
            this.v1(function (a) { return a.aac(); });
        }
    };
    Object.defineProperty(CategoryChart.prototype, "xAxis", {
        get: function () {
            return this._xAxis;
        },
        set: function (a) {
            this._xAxis = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "yAxis", {
        get: function () {
            return this._yAxis;
        },
        set: function (a) {
            this._yAxis = a;
        },
        enumerable: false,
        configurable: true
    });
    CategoryChart.prototype.aie = function (a, b) {
        switch (a) {
            case 2: return this.df(1);
            case 3: return this.df(10);
            case 0: return this.df(0);
            case 1: return this.df(2);
            case 6: return this.df(6);
            case 7: return this.df(7);
            case 4: return this.df(4);
            case 5: return this.df(5);
            case 8: return this.df(8);
            case 9: return this.aid(b);
            default: return this.df(1);
        }
    };
    CategoryChart.prototype.aid = function (a) {
        return this.df(a);
    };
    CategoryChart.prototype.be = function (a) {
        switch (this.ah6) {
            case 1: return 2;
            case 0: return 0;
            case 3: return 10;
            case 6: return 6;
            case 7: return 7;
            case 5: return 5;
            case 4: return 4;
            case 8: return 8;
            case 9: return a.suggestedSeries;
            default:
            case 2: return 1;
        }
    };
    CategoryChart.prototype.dc = function (a, b) {
        var c = this.aie(this.ah6, a.suggestedSeries);
        c.abr = a.findMatchingHint(0).path;
        c.xAxis = this.xAxis;
        c.yAxis = this.yAxis;
        return c;
    };
    CategoryChart.prototype.w8 = function (a) {
        if (a.suggestedSecondaryAxis == 2) {
            this.yAxis.lo = true;
            this.yAxis.mm = 10;
        }
    };
    CategoryChart.prototype.xb = function () {
        this.yAxis.lo = this.aja;
        this.yAxis.mm = this.akn;
    };
    CategoryChart.prototype.get_h1 = function () {
        return ((function () {
            var $ret = new List$1(IDataSeriesAdapterRule_$type, 0);
            $ret.add(new SimpleCategorySeriesRule());
            $ret.add(new SubCollectionsRule());
            return $ret;
        })());
    };
    Object.defineProperty(CategoryChart.prototype, "h1", {
        get: function () {
            return this.get_h1();
        },
        enumerable: false,
        configurable: true
    });
    CategoryChart.prototype.ur = function (a, b) {
        var c = typeCast(HorizontalAnchoredCategorySeries.$, a);
        if (c != null) {
            c.aa1 = this.ah8;
            c.xf = this.c2(a, b);
        }
    };
    CategoryChart.prototype.alu = function (a) {
        this.alv(function (b, c) { return a(b); });
    };
    CategoryChart.prototype.alv = function (a) {
        if (this.dataChart == null) {
            return;
        }
        for (var b = 0; b < this.dataChart.series.count; b++) {
            var c = typeCast(HorizontalAnchoredCategorySeries.$, this.dataChart.series._inner[b]);
            if (c == null) {
                continue;
            }
            a(c, b);
        }
    };
    CategoryChart.prototype.aao = function () {
        return this.xAxis;
    };
    CategoryChart.prototype.aap = function () {
        return this.yAxis;
    };
    CategoryChart.prototype.aih = function () {
        return this.df(30);
    };
    CategoryChart.prototype.aii = function () {
        return this.df(31);
    };
    CategoryChart.prototype.hy = function (a, b) {
        var c = _super.prototype.hy.call(this, a, b);
        if (c != null) {
            var d = new List$1(Series.$, 0);
            if (this.aip) {
                d.add(this.aih());
            }
            if (this.aiq) {
                d.add(this.aii());
            }
            for (var e = 0; e < d.count; e++) {
                var f = d._inner[e];
                f.name = a + getInstanceType(f).typeName;
                c.add(f);
            }
        }
        return c;
    };
    CategoryChart.prototype.ba = function () {
        if (this.a9 == 0) {
            return 1;
        }
        else {
            return this.a9;
        }
    };
    CategoryChart.prototype.xf = function (a, b, c) {
        _super.prototype.xf.call(this, a, b, c);
        if (this.bf.dataSeries.count > 0) {
            if (stringIsNullOrEmpty(this.nz)) {
                this.ce.setXMemberPath(a, c.getMemberPathFor(16));
            }
            if (stringIsNullOrEmpty(this.n1)) {
                this.ce.setYMemberPath(a, c.getMemberPathFor(0));
            }
            if (stringIsNullOrEmpty(this.nm)) {
                this.ce.setLabelMemberPath(a, c.getMemberPathFor(0));
            }
            if (stringIsNullOrEmpty(this.ni)) {
                this.ce.setContentMemberPath(a, c.getMemberPathFor(0));
            }
        }
    };
    CategoryChart.prototype.g4 = function () {
        if (this.crosshairsDisplayMode == 4 || this.crosshairsDisplayMode == 3) {
            return true;
        }
        else if (this.crosshairsDisplayMode == 0) {
            if (this.ah6 == 2 || this.ah6 == 8) {
                return false;
            }
            else if (this.ah6 == 9 && this.bf != null && this.bf.dataSeries != null && this.bf.dataSeries.count > 0) {
                var a = this.bf.dataSeries._inner[0].suggestedSeries;
                if (a == 1 || a == 8) {
                    return false;
                }
            }
            return true;
        }
        return false;
    };
    CategoryChart.prototype.get_hb = function () {
        return DVContainer.instance.checkLoaded("CategoryChartToolbarFactoryManager");
    };
    CategoryChart.prototype.wd = function (a, b, c) {
        var _this = this;
        _super.prototype.wd.call(this, a, b, c);
        switch (a) {
            case "ChartType":
                this.u8();
                break;
            case "MarkerCollisionAvoidance":
                this.alu(function (d) { return d.aa1 = _this.ah8; });
                break;
            case "IsTransitionInEnabled":
                this.alu(function (d) { return d.zq = _this.ai3; });
                break;
            case "IsSplineShapePartOfRange":
                this.alu(function (d) {
                    if (d.f1) {
                        d.r8(_this.ai2);
                    }
                });
                break;
            case "TransitionInMode":
                this.alu(function (d) { return d.za = _this.aia; });
                break;
            case "TransitionInSpeedType":
                this.alu(function (d) { return d.c6 = _this.aik; });
                break;
            case "XAxisInterval":
                this.xAxis.mw = this.aj2;
                break;
            case "XAxisMinorInterval":
                this.xAxis.mx = this.aj5;
                break;
            case "XAxisGap":
                this.xAxis.k5 = this.aj1;
                break;
            case "XAxisOverlap":
                this.xAxis.le = this.aj6;
                break;
            case "XAxisMinimumGapSize":
                this.xAxis.ld = this.aj4;
                break;
            case "XAxisMaximumGap":
                this.xAxis.lc = this.aj3;
                break;
            case "XAxisZoomMaximumCategoryRange":
                this.xAxis.zoomMaximumCategoryRange = this.aj7;
                break;
            case "XAxisZoomMaximumItemSpan":
                this.xAxis.zoomMaximumItemSpan = this.aj8;
                break;
            case "XAxisZoomToCategoryRange":
                this.xAxis.zoomToCategoryRange = this.aj9;
                break;
            case "XAxisZoomToCategoryStart":
                this.xAxis.zoomToCategoryStart = this.aka;
                break;
            case "XAxisZoomToItemSpan":
                this.xAxis.zoomToItemSpan = this.akb;
                break;
            case "YAxisInterval":
                this.yAxis.l8 = this.ake;
                break;
            case "YAxisFavorLabellingScaleEnd":
                this.yAxis.lj = this.ai9;
                break;
            case "YAxisAutoRangeBufferMode":
                this.yAxis.ky = this.ah4;
                break;
            case "YAxisIsLogarithmic":
                this.yAxis.lo = this.aja;
                break;
            case "YAxisLogarithmBase":
                this.yAxis.mm = this.akn;
                break;
            case "YAxisMinimumValue":
                this.yAxis.mc = this.akg;
                break;
            case "YAxisMaximumValue":
                this.yAxis.mb = this.akf;
                break;
            case "YAxisMinorInterval":
                this.yAxis.md = this.akh;
                break;
            case "NegativeBrushes":
            case "NegativeOutlines":
                this.alv(function (d, e) {
                    if (d.fn) {
                        d.r7(ArrayExtension.getModulus$1(Brush.$, _this.ahz, e), ArrayExtension.getModulus$1(Brush.$, _this.ah0, e));
                    }
                });
                break;
            case "YAxisAbbreviateLargeNumbers":
                this.agg(function (d) { return d.lf = _this.ai7; });
                break;
            case "IsCategoryHighlightingEnabled":
            case "IsItemHighlightingEnabled":
                this.u8();
                break;
            case "AutoMarginAndAngleUpdateMode":
                this.v1(function (d) { return d.w6 = _this.ah2; });
                break;
            case "ShouldAutoExpandMarginForInitialLabels":
                this.v1(function (d) { return d.x1 = _this.ai4; });
                break;
            case CategoryChart.ak1:
                this.v1(function (d) { return d.x4 = _this.ai5; });
                break;
            case "AutoExpandMarginExtraPadding":
                this.v1(function (d) { return d.yr = _this.ajt; });
                break;
            case "AutoExpandMarginMaximumValue":
                this.v1(function (d) { return d.ys = _this.aju; });
                break;
            case CategoryChart.ak8:
                this.agc(function (d) { return d.b1 = _this.ai6; }, a);
                break;
            case CategoryChart.alm:
                this.agg(function (d) { return d.b1 = _this.ai8; });
                break;
        }
    };
    CategoryChart.$t = markType(CategoryChart, 'CategoryChart', XYChart.$);
    CategoryChart.ak1 = "ShouldConsiderAutoRotationForInitialLabels";
    CategoryChart.ak8 = "XAxisEnhancedIntervalPreferMoreCategoryLabels";
    CategoryChart.alm = "YAxisEnhancedIntervalPreferMoreCategoryLabels";
    return CategoryChart;
}(XYChart));
export { CategoryChart };
