/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { DomainChart } from "./DomainChart";
import { fromEnum, enumGetBox, markType } from "igniteui-angular-core";
import { HorizontalAlignment_$type } from "igniteui-angular-core";
import { VerticalAlignment_$type } from "igniteui-angular-core";
import { Visibility_$type } from "igniteui-angular-core";
import { YAxisLabelLocation_$type } from "./YAxisLabelLocation";
import { XAxisLabelLocation_$type } from "./XAxisLabelLocation";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { AxisDefaults } from "./AxisDefaults";
import { TitleSettings } from "./TitleSettings";
import { ScalerParams } from "./ScalerParams";
import { DeviceUtils } from "igniteui-angular-core";
/**
 * @hidden
 */
var XYChart = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(XYChart, _super);
    function XYChart() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.aaq = null;
        _this.aar = null;
        _this.aa7 = 0;
        _this.aa9 = 5;
        _this.aa8 = 0;
        _this.aa6 = 5;
        _this.abq = 5;
        _this.abs = 0;
        _this.abr = 5;
        _this.abp = 0;
        _this.agt = null;
        _this.ag0 = null;
        _this.agr = null;
        _this.ags = null;
        _this.abk = 0;
        _this.ab3 = 0;
        _this.abj = NaN;
        _this.ab2 = NaN;
        _this.abm = NaN;
        _this.ab5 = NaN;
        _this.abl = NaN;
        _this.ab4 = NaN;
        _this.abi = NaN;
        _this.ab1 = NaN;
        _this.agz = null;
        _this.ag6 = null;
        _this.adh = null;
        _this.adl = null;
        _this.adj = null;
        _this.adn = null;
        _this.adc = null;
        _this.add = null;
        _this.agu = null;
        _this.ag1 = null;
        _this.aba = DeviceUtils.g(1);
        _this.abt = DeviceUtils.g(1);
        _this.abd = DeviceUtils.g(1);
        _this.abw = DeviceUtils.g(1);
        _this.agw = null;
        _this.ag3 = null;
        _this.agx = null;
        _this.ag4 = null;
        _this.abe = DeviceUtils.g(1);
        _this.abx = DeviceUtils.g(1);
        _this.abf = DeviceUtils.g(8);
        _this.aby = 0;
        _this.agy = null;
        _this.ag5 = null;
        _this.abg = DeviceUtils.g(1);
        _this.abz = DeviceUtils.g(1);
        _this.adi = null;
        _this.adm = null;
        _this.agv = null;
        _this.ag2 = null;
        _this.aa5 = 0;
        _this.abo = 0;
        _this.aa4 = NaN;
        _this.abn = NaN;
        _this.abb = NaN;
        _this.abu = NaN;
        _this.abc = NaN;
        _this.abv = NaN;
        _this.abh = 0;
        _this.ab0 = -90;
        _this.aa0 = false;
        _this.aa1 = false;
        _this.agm = 1;
        _this.ahp = 1;
        _this.agl = 1;
        _this.agn = 2;
        _this.ahn = 0;
        _this.aho = 1;
        _this.aht = 0;
        _this.ahu = 0;
        _this.aay = 4;
        _this.aaw = 4;
        _this.adg = null;
        _this.aak = null;
        _this.adk = null;
        _this.aal = null;
        return _this;
    }
    XYChart.prototype.provideContainer = function (a) {
        if (a != null) {
            var b = this.aao();
            var c = this.aap();
            if (b != null) {
                b.provideRenderer(a);
            }
            if (c != null) {
                c.provideRenderer(a);
            }
        }
        _super.prototype.provideContainer.call(this, a);
    };
    XYChart.prototype.vm = function () {
        _super.prototype.vm.call(this);
        var a = this.aao();
        var b = this.aap();
        if (a != null && a.az != null) {
            this.ag9 = a.az.textColor;
        }
        if (b != null && b.az != null) {
            this.ahg = b.az.textColor;
        }
        this.ahe = AxisDefaults.axis_TickBrush;
        this.ahl = AxisDefaults.axis_TickBrush;
        this.aha = AxisDefaults.axis_MajorBrush;
        this.ahh = AxisDefaults.axis_MajorBrush;
        this.ahd = AxisDefaults.axis_LineBrush;
        this.ahk = AxisDefaults.axis_LineBrush;
    };
    XYChart.prototype.wh = function (a, b, c) {
        var _this = this;
        _super.prototype.wh.call(this, a, b, c);
        switch (a) {
            case "XAxisLabelLeftMargin":
                this.agd(function (d) { return d.leftMargin = _this.acd; });
                break;
            case "XAxisLabelTopMargin":
                this.agd(function (d) { return d.topMargin = _this.acf; });
                break;
            case "XAxisLabelRightMargin":
                this.agd(function (d) { return d.rightMargin = _this.ace; });
                break;
            case "XAxisLabelBottomMargin":
                this.agd(function (d) { return d.bottomMargin = _this.acc; });
                break;
            case "YAxisLabelLeftMargin":
                this.agi(function (d) { return d.leftMargin = _this.acw; });
                break;
            case "YAxisLabelTopMargin":
                this.agi(function (d) { return d.topMargin = _this.acy; });
                break;
            case "YAxisLabelRightMargin":
                this.agi(function (d) { return d.rightMargin = _this.acx; });
                break;
            case "YAxisLabelBottomMargin":
                this.agi(function (d) { return d.bottomMargin = _this.acv; });
                break;
            case "ActualItemsSource":
            case "ShouldDisplayMockData":
            case "ShouldUseSkeletonStyleForMockData":
                this.ag7 = this.zi(this.ag9);
                this.ag8 = this.zi(this.ahg);
                break;
            case "XAxisLabelTextColor":
                this.ag7 = this.zi(this.ag9);
                break;
            case "YAxisLabelTextColor":
                this.ag8 = this.zi(this.ahg);
                break;
            case "ActualXAxisLabelTextColor":
                this.agd(function (d) { return d.textColor = _this.ag7; });
                break;
            case "ActualYAxisLabelTextColor":
                this.agi(function (d) { return d.textColor = _this.ag8; });
                break;
            case "XAxisTitleMargin":
                this.agf(function (d) { return d.margin = _this.acq; });
                break;
            case "YAxisTitleMargin":
                this.agk(function (d) { return d.margin = _this.ac9; });
                break;
            case "XAxisTitleLeftMargin":
                this.agf(function (d) { return d.leftMargin = _this.acp; });
                break;
            case "YAxisTitleLeftMargin":
                this.agk(function (d) { return d.leftMargin = _this.ac8; });
                break;
            case "XAxisTitleTopMargin":
                this.agf(function (d) { return d.topMargin = _this.acs; });
                break;
            case "YAxisTitleTopMargin":
                this.agk(function (d) { return d.topMargin = _this.adb; });
                break;
            case "XAxisTitleRightMargin":
                this.agf(function (d) { return d.rightMargin = _this.acr; });
                break;
            case "YAxisTitleRightMargin":
                this.agk(function (d) { return d.rightMargin = _this.ada; });
                break;
            case "XAxisTitleBottomMargin":
                this.agf(function (d) { return d.bottomMargin = _this.aco; });
                break;
            case "YAxisTitleBottomMargin":
                this.agk(function (d) { return d.bottomMargin = _this.ac7; });
                break;
            case "XAxisTitleTextColor":
                this.agf(function (d) { return d.textColor = _this.ahf; });
                break;
            case "YAxisTitleTextColor":
                this.agk(function (d) { return d.textColor = _this.ahm; });
                break;
            case "XAxisFormatLabel":
                this.agb(function (d) { return d.au = _this.aas; });
                break;
            case "YAxisFormatLabel":
                this.agg(function (d) { return d.au = _this.aat; });
                break;
        }
    };
    Object.defineProperty(XYChart.prototype, "aas", {
        get: function () {
            return this.aaq;
        },
        set: function (a) {
            var b = this.aas;
            if (a != b) {
                this.aaq = a;
                this.wd("XAxisFormatLabel", b, this.aas);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aat", {
        get: function () {
            return this.aar;
        },
        set: function (a) {
            var b = this.aat;
            if (a != b) {
                this.aar = a;
                this.wd("YAxisFormatLabel", b, this.aat);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acd", {
        get: function () {
            return this.aa7;
        },
        set: function (a) {
            var b = this.acd;
            if (a != b) {
                this.aa7 = a;
                this.wd("XAxisLabelLeftMargin", b, this.acd);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acf", {
        get: function () {
            return this.aa9;
        },
        set: function (a) {
            var b = this.acf;
            if (a != b) {
                this.aa9 = a;
                this.wd("XAxisLabelTopMargin", b, this.acf);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ace", {
        get: function () {
            return this.aa8;
        },
        set: function (a) {
            var b = this.ace;
            if (a != b) {
                this.aa8 = a;
                this.wd("XAxisLabelRightMargin", b, this.ace);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acc", {
        get: function () {
            return this.aa6;
        },
        set: function (a) {
            var b = this.acc;
            if (a != b) {
                this.aa6 = a;
                this.wd("XAxisLabelBottomMargin", b, this.acc);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acw", {
        get: function () {
            return this.abq;
        },
        set: function (a) {
            var b = this.acw;
            if (a != b) {
                this.abq = a;
                this.wd("YAxisLabelLeftMargin", b, this.acw);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acy", {
        get: function () {
            return this.abs;
        },
        set: function (a) {
            var b = this.acy;
            if (a != b) {
                this.abs = a;
                this.wd("YAxisLabelTopMargin", b, this.acy);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acx", {
        get: function () {
            return this.abr;
        },
        set: function (a) {
            var b = this.acx;
            if (a != b) {
                this.abr = a;
                this.wd("YAxisLabelRightMargin", b, this.acx);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acv", {
        get: function () {
            return this.abp;
        },
        set: function (a) {
            var b = this.acv;
            if (a != b) {
                this.abp = a;
                this.wd("YAxisLabelBottomMargin", b, this.acv);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ag9", {
        get: function () {
            return this.agt;
        },
        set: function (a) {
            var b = this.ag9;
            if (a != b) {
                this.agt = a;
                this.wd("XAxisLabelTextColor", b, this.ag9);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ahg", {
        get: function () {
            return this.ag0;
        },
        set: function (a) {
            var b = this.ahg;
            if (a != b) {
                this.ag0 = a;
                this.wd("YAxisLabelTextColor", b, this.ahg);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ag7", {
        get: function () {
            return this.agr;
        },
        set: function (a) {
            var b = this.agr;
            if (a != b) {
                this.agr = a;
                this.wd("ActualXAxisLabelTextColor", b, this.ag7);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ag8", {
        get: function () {
            return this.ags;
        },
        set: function (a) {
            var b = this.ags;
            if (a != b) {
                this.ags = a;
                this.wd("ActualYAxisLabelTextColor", b, this.ag8);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acq", {
        get: function () {
            return this.abk;
        },
        set: function (a) {
            var b = this.acq;
            if (a != b) {
                this.abk = a;
                this.wd("XAxisTitleMargin", b, this.acq);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ac9", {
        get: function () {
            return this.ab3;
        },
        set: function (a) {
            var b = this.ac9;
            if (a != b) {
                this.ab3 = a;
                this.wd("YAxisTitleMargin", b, this.ac9);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acp", {
        get: function () {
            return this.abj;
        },
        set: function (a) {
            var b = this.acp;
            if (a != b) {
                this.abj = a;
                this.wd("XAxisTitleLeftMargin", b, this.acp);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ac8", {
        get: function () {
            return this.ab2;
        },
        set: function (a) {
            var b = this.ac8;
            if (a != b) {
                this.ab2 = a;
                this.wd("YAxisTitleLeftMargin", b, this.ac8);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acs", {
        get: function () {
            return this.abm;
        },
        set: function (a) {
            var b = this.acs;
            if (a != b) {
                this.abm = a;
                this.wd("XAxisTitleTopMargin", b, this.acs);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "adb", {
        get: function () {
            return this.ab5;
        },
        set: function (a) {
            var b = this.adb;
            if (a != b) {
                this.ab5 = a;
                this.wd("YAxisTitleTopMargin", b, this.adb);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acr", {
        get: function () {
            return this.abl;
        },
        set: function (a) {
            var b = this.acr;
            if (a != b) {
                this.abl = a;
                this.wd("XAxisTitleRightMargin", b, this.acr);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ada", {
        get: function () {
            return this.ab4;
        },
        set: function (a) {
            var b = this.ada;
            if (a != b) {
                this.ab4 = a;
                this.wd("YAxisTitleRightMargin", b, this.ada);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aco", {
        get: function () {
            return this.abi;
        },
        set: function (a) {
            var b = this.aco;
            if (a != b) {
                this.abi = a;
                this.wd("XAxisTitleBottomMargin", b, this.aco);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ac7", {
        get: function () {
            return this.ab1;
        },
        set: function (a) {
            var b = this.ac7;
            if (a != b) {
                this.ab1 = a;
                this.wd("YAxisTitleBottomMargin", b, this.ac7);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ahf", {
        get: function () {
            return this.agz;
        },
        set: function (a) {
            var b = this.ahf;
            if (a != b) {
                this.agz = a;
                this.wd("XAxisTitleTextColor", b, this.ahf);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ahm", {
        get: function () {
            return this.ag6;
        },
        set: function (a) {
            var b = this.ahm;
            if (a != b) {
                this.ag6 = a;
                this.wd("YAxisTitleTextColor", b, this.ahm);
            }
        },
        enumerable: false,
        configurable: true
    });
    XYChart.prototype.wi = function (a, b, c) {
        var _this = this;
        _super.prototype.wi.call(this, a, b, c);
        switch (a) {
            case "XAxisLabelTextStyle":
                this.agd(function (d) { return d.textStyle = _this.ad5; });
                break;
            case "YAxisLabelTextStyle":
                this.agi(function (d) { return d.textStyle = _this.afc; });
                break;
            case "XAxisTitleTextStyle":
                this.agf(function (d) { return d.textStyle = _this.aev; });
                break;
            case "YAxisTitleTextStyle":
                this.agk(function (d) { return d.textStyle = _this.af2; });
                break;
        }
    };
    Object.defineProperty(XYChart.prototype, "ad5", {
        get: function () {
            return this.adh;
        },
        set: function (a) {
            var b = this.ad5;
            if (a != b) {
                this.adh = a;
                this.wd("XAxisLabelTextStyle", b, this.ad5);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "afc", {
        get: function () {
            return this.adl;
        },
        set: function (a) {
            var b = this.afc;
            if (a != b) {
                this.adl = a;
                this.wd("YAxisLabelTextStyle", b, this.afc);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aev", {
        get: function () {
            return this.adj;
        },
        set: function (a) {
            var b = this.aev;
            if (a != b) {
                this.adj = a;
                this.wd("XAxisTitleTextStyle", b, this.aev);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "af2", {
        get: function () {
            return this.adn;
        },
        set: function (a) {
            var b = this.af2;
            if (a != b) {
                this.adn = a;
                this.wd("YAxisTitleTextStyle", b, this.af2);
            }
        },
        enumerable: false,
        configurable: true
    });
    XYChart.prototype.af8 = function (a) {
        var _this = this;
        this.af5(a, function (b) { return b.leftMargin = _this.acd; });
        this.af5(a, function (b) { return b.topMargin = _this.acf; });
        this.af5(a, function (b) { return b.rightMargin = _this.ace; });
        this.af5(a, function (b) { return b.bottomMargin = _this.acc; });
        this.af5(a, function (b) { return b.textColor = _this.ag7; });
        this.af6(a, function (b) { return b.textColor = _this.ahf; });
        this.af6(a, function (b) { return b.leftMargin = _this.acp; });
        this.af6(a, function (b) { return b.topMargin = _this.acs; });
        this.af6(a, function (b) { return b.rightMargin = _this.acr; });
        this.af6(a, function (b) { return b.bottomMargin = _this.aco; });
        this.af5(a, function (b) { return b.textStyle = _this.ad5; });
        this.af6(a, function (b) { return b.textStyle = _this.aev; });
    };
    XYChart.prototype.aga = function (a) {
        var _this = this;
        this.af5(a, function (b) { return b.leftMargin = _this.acw; });
        this.af5(a, function (b) { return b.topMargin = _this.acy; });
        this.af5(a, function (b) { return b.rightMargin = _this.acx; });
        this.af5(a, function (b) { return b.bottomMargin = _this.acv; });
        this.af5(a, function (b) { return b.textColor = _this.ag8; });
        this.af6(a, function (b) { return b.textColor = _this.ahm; });
        this.af6(a, function (b) { return b.leftMargin = _this.ac8; });
        this.af6(a, function (b) { return b.topMargin = _this.adb; });
        this.af6(a, function (b) { return b.rightMargin = _this.ada; });
        this.af6(a, function (b) { return b.bottomMargin = _this.ac7; });
        this.af5(a, function (b) { return b.textStyle = _this.afc; });
        this.af6(a, function (b) { return b.textStyle = _this.af2; });
    };
    XYChart.prototype.w9 = function (a) {
        var b = this.be(a);
        var c = this.dc(a, b);
        if (c == null) {
            return;
        }
        c.itemsSource = this.h6(a);
        if (a.highlightedData != null) {
            c.highlightedItemsSource = this.h7(a);
        }
        c.name = this.q0(a);
        c.title = this.q1(a, b);
        this.dataChart.series.add(c);
    };
    XYChart.prototype.agb = function (a) {
        this.agc(a, null);
    };
    XYChart.prototype.agc = function (a, b) {
        a(this.aao());
    };
    XYChart.prototype.agh = function (a, b) {
        a(this.aap());
    };
    XYChart.prototype.agg = function (a) {
        this.agh(a, true);
    };
    XYChart.prototype.u5 = function (a, b) {
        this.agb(a);
        this.agh(a, b);
    };
    XYChart.prototype.agf = function (a) {
        this.af6(this.aao(), a);
    };
    XYChart.prototype.agk = function (a) {
        this.af6(this.aap(), a);
    };
    XYChart.prototype.agi = function (a) {
        this.af5(this.aap(), a);
    };
    XYChart.prototype.agd = function (a) {
        this.af5(this.aao(), a);
    };
    XYChart.prototype.ab6 = function (a) {
        var b = this.aao();
        return b.el(a, new ScalerParams(1, this.zr, this.zq, b.ch));
    };
    XYChart.prototype.ab8 = function (a) {
        var b = this.aao();
        return b.eo(a, new ScalerParams(1, this.zr, this.zq, b.ch));
    };
    XYChart.prototype.ab7 = function (a) {
        var b = this.aap();
        return b.el(a, new ScalerParams(1, this.zr, this.zq, b.ch));
    };
    XYChart.prototype.ab9 = function (a) {
        var b = this.aap();
        return b.eo(a, new ScalerParams(1, this.zr, this.zq, b.ch));
    };
    XYChart.prototype.w6 = function (a) {
        _super.prototype.w6.call(this, a);
        if (a == null) {
            return;
        }
        if (a.axes != null) {
            var b = this.aao();
            var c = this.aap();
            if (a.axes.contains(b)) {
                a.axes.remove(b);
            }
            if (a.axes.contains(c)) {
                a.axes.remove(c);
            }
        }
    };
    XYChart.adq = function (a, b) {
        var e_1, _a;
        try {
            for (var _b = __values(fromEnum(b)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                var d = c.findMatchingHint(16);
                if (d != null) {
                    var e = d.path;
                    return e;
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        return null;
    };
    XYChart.prototype.vh = function (a, b) {
        _super.prototype.vh.call(this, a, b);
        if (a == this.dataChart) {
            this.dataChart.axes.add(this.aao());
            this.dataChart.axes.add(this.aap());
        }
    };
    XYChart.prototype.af7 = function (a) {
        var _this = this;
        if (a != null && this.l4 != null && a.fn == null) {
            a.provideRenderer(this.l4);
        }
        a.jz = this.aha;
        a.et = this.acg;
        a.j0 = this.ahb;
        a.ew = this.acj;
        a.j2 = this.ahd;
        a.fi = this.ack;
        a.j1 = this.ahc;
        a.fj = this.acl;
        a.j3 = this.ahe;
        a.fk = this.acm;
        a.c4 = true;
        a.cu = this.shouldAvoidAxisAnnotationCollisions;
        a.cw = this.shouldAvoidAxisAnnotationCollisions;
        var b = a == this.aao();
        if (b) {
            a.g8 = this.aem;
        }
        a.f2 = this.ade;
        a.gi = this.adw;
        a.ah = this.aam;
        this.af5(a, function (c) { return c.angle = _this.acb; });
        this.af5(a, function (c) {
            if (c.extent != _this.aca) {
                c.extent = _this.aca;
            }
        });
        this.af5(a, function (c) {
            if (c.maximumExtent != _this.ach) {
                c.maximumExtent = _this.ach;
            }
        });
        this.af5(a, function (c) {
            if (c.maximumExtentPercentage != _this.aci) {
                c.maximumExtentPercentage = _this.aci;
            }
        });
        this.af5(a, function (c) { return c.horizontalAlignment = _this.ago; });
        this.af5(a, function (c) { return c.verticalAlignment = _this.ahq; });
        this.af5(a, function (c) { return c.visibility = _this.ahv; });
        this.af5(a, function (c) { return c.location = _this.aau(_this.aax); });
        this.af6(a, function (c) { return c.horizontalAlignment = _this.agp; });
        this.af6(a, function (c) { return c.angle = _this.acn; });
        this.af8(a);
    };
    XYChart.prototype.af9 = function (a) {
        var _this = this;
        if (a == null) {
            return;
        }
        if (this.l4 != null && a.fn == null) {
            a.provideRenderer(this.l4);
        }
        a.cu = this.shouldAvoidAxisAnnotationCollisions;
        a.cw = this.shouldAvoidAxisAnnotationCollisions;
        this.af5(a, function (b) { return b.angle = _this.acu; });
        this.af5(a, function (b) {
            if (b.extent != _this.act) {
                b.extent = _this.act;
            }
        });
        this.af5(a, function (b) {
            if (b.maximumExtent != _this.ac0) {
                b.maximumExtent = _this.ac0;
            }
        });
        this.af5(a, function (b) {
            if (b.maximumExtentPercentage != _this.ac1) {
                b.maximumExtentPercentage = _this.ac1;
            }
        });
        this.af5(a, function (b) { return b.horizontalAlignment = _this.agq; });
        this.af5(a, function (b) { return b.verticalAlignment = _this.ahr; });
        this.af5(a, function (b) { return b.visibility = _this.ahw; });
        this.af5(a, function (b) { return b.location = _this.aav(_this.aaz); });
        this.af6(a, function (b) { return b.verticalAlignment = _this.ahs; });
        this.af6(a, function (b) { return b.angle = _this.ac6; });
        a.jz = this.ahh;
        a.et = this.acz;
        a.j0 = this.ahi;
        a.ew = this.ac2;
        a.j2 = this.ahk;
        a.fi = this.ac3;
        a.j1 = this.ahj;
        a.fj = this.ac4;
        a.j3 = this.ahl;
        a.fk = this.ac5;
        var b = a == this.aap();
        if (b) {
            a.g8 = this.aft;
        }
        a.gi = this.ae3;
        a.ah = this.aan;
        this.aga(a);
    };
    XYChart.prototype.ve = function () {
        _super.prototype.ve.call(this);
        this.af7(this.aao());
        this.af9(this.aap());
    };
    XYChart.prototype.af5 = function (a, b) {
        if (a == null) {
            return;
        }
        if (a.az == null) {
            a.az = new AxisLabelSettings();
            a.az.angle = a.d7();
            a.az.bottomMargin = a.d8();
            a.az.leftMargin = a.d9();
            a.az.rightMargin = a.ea();
            a.az.topMargin = a.eb();
            a.az.horizontalAlignment = a.ju();
            a.az.location = a.a0();
            a.az.verticalAlignment = a.ko();
        }
        b(a.az);
    };
    XYChart.prototype.af6 = function (a, b) {
        if (a == null) {
            return;
        }
        if (a.bf == null) {
            a.bf = new TitleSettings();
            a.bf.bottomMargin = a.ed();
            a.bf.leftMargin = a.ee();
            a.bf.rightMargin = a.ef();
            a.bf.topMargin = a.eg();
            a.bf.location = a.a1();
            a.bf.angle = a.ec();
            a.bf.horizontalAlignment = a.jv();
            a.bf.verticalAlignment = a.kp();
        }
        b(a.bf);
    };
    XYChart.prototype.wd = function (a, b, c) {
        var _this = this;
        _super.prototype.wd.call(this, a, b, c);
        switch (a) {
            case "XAxisLabelAngle":
                this.agd(function (d) { return d.angle = _this.acb; });
                break;
            case "YAxisLabelAngle":
                this.agi(function (d) { return d.angle = _this.acu; });
                break;
            case "XAxisLabelHorizontalAlignment":
                this.agd(function (d) { return d.horizontalAlignment = _this.ago; });
                break;
            case "YAxisLabelHorizontalAlignment":
                this.agi(function (d) { return d.horizontalAlignment = _this.agq; });
                break;
            case "XAxisLabelVerticalAlignment":
                this.agd(function (d) { return d.verticalAlignment = _this.ahq; });
                break;
            case "YAxisLabelVerticalAlignment":
                this.agi(function (d) { return d.verticalAlignment = _this.ahr; });
                break;
            case "XAxisLabelVisibility":
                this.agd(function (d) { return d.visibility = _this.ahv; });
                break;
            case "YAxisLabelVisibility":
                this.agi(function (d) { return d.visibility = _this.ahw; });
                break;
            case "XAxisLabel":
                this.agb(function (d) { return d.f2 = _this.ade; });
                break;
            case "YAxisLabel":
                this.agg(function (d) { return d.f2 = _this.adf; });
                break;
            case "XAxisLabelFormat":
                this.agb(function (d) { return d.gi = _this.adw; });
                break;
            case "XAxisLabelFormatSpecifiers":
                this.agb(function (d) { return d.ah = _this.aam; });
                break;
            case "YAxisLabelFormat":
                this.agg(function (d) { return d.gi = _this.ae3; });
                break;
            case "YAxisLabelFormatSpecifiers":
                this.agg(function (d) { return d.ah = _this.aan; });
                break;
            case "XAxisTitleAngle":
                this.agf(function (d) { return d.angle = _this.acn; });
                break;
            case "YAxisTitleAngle":
                this.agk(function (d) { return d.angle = _this.ac6; });
                break;
            case "XAxisTitleAlignment":
                this.agf(function (d) { return d.horizontalAlignment = _this.agp; });
                break;
            case "YAxisTitleAlignment":
                this.agk(function (d) { return d.verticalAlignment = _this.ahs; });
                break;
            case "XAxisTitle":
                this.agb(function (d) { return d.g8 = _this.aem; });
                break;
            case "YAxisTitle":
                this.agh(function (d) { return d.g8 = _this.aft; }, false);
                break;
            case "XAxisMajorStroke":
                this.agc(function (d) { return d.jz = _this.aha; }, a);
                break;
            case "YAxisMajorStroke":
                this.agg(function (d) { return d.jz = _this.ahh; });
                break;
            case "XAxisMajorStrokeThickness":
                this.agc(function (d) { return d.et = _this.acg; }, a);
                break;
            case "YAxisMajorStrokeThickness":
                this.agg(function (d) { return d.et = _this.acz; });
                break;
            case "XAxisMinorStroke":
                this.agb(function (d) { return d.j0 = _this.ahb; });
                break;
            case "YAxisMinorStroke":
                this.agg(function (d) { return d.j0 = _this.ahi; });
                break;
            case "XAxisMinorStrokeThickness":
                this.agb(function (d) { return d.ew = _this.acj; });
                break;
            case "YAxisMinorStrokeThickness":
                this.agg(function (d) { return d.ew = _this.ac2; });
                break;
            case "XAxisTickLength":
                this.agb(function (d) { return d.fj = _this.acl; });
                break;
            case "YAxisTickLength":
                this.agg(function (d) { return d.fj = _this.ac4; });
                break;
            case "XAxisTickStroke":
                this.agb(function (d) { return d.j3 = _this.ahe; });
                break;
            case "YAxisTickStroke":
                this.agg(function (d) { return d.j3 = _this.ahl; });
                break;
            case "XAxisTickStrokeThickness":
                this.agb(function (d) { return d.fk = _this.acm; });
                break;
            case "YAxisTickStrokeThickness":
                this.agg(function (d) { return d.fk = _this.ac5; });
                break;
            case "XAxisStroke":
                this.agb(function (d) { return d.j2 = _this.ahd; });
                break;
            case "YAxisStroke":
                this.agg(function (d) { return d.j2 = _this.ahk; });
                break;
            case "XAxisStrokeThickness":
                this.agb(function (d) { return d.fi = _this.ack; });
                break;
            case "YAxisStrokeThickness":
                this.agg(function (d) { return d.fi = _this.ac3; });
                break;
            case "XAxisExtent":
                this.agd(function (d) { return d.extent = _this.aca; });
                break;
            case "YAxisExtent":
                this.agi(function (d) { return d.extent = _this.act; });
                break;
            case "XAxisMaximumExtent":
                this.agd(function (d) { return d.maximumExtent = _this.ach; });
                break;
            case "YAxisMaximumExtent":
                this.agi(function (d) { return d.maximumExtent = _this.ac0; });
                break;
            case "XAxisMaximumExtentPercentage":
                this.agd(function (d) { return d.maximumExtentPercentage = _this.aci; });
                break;
            case "YAxisMaximumExtentPercentage":
                this.agi(function (d) { return d.maximumExtentPercentage = _this.ac1; });
                break;
            case "XAxisStrip":
                this.agb(function (d) { return d.j1 = _this.ahc; });
                break;
            case "YAxisStrip":
                this.agg(function (d) { return d.j1 = _this.ahj; });
                break;
            case "XAxisInverted":
                this.agb(function (d) { return d.ch = _this.aa2; });
                break;
            case "YAxisInverted":
                this.agg(function (d) { return d.ch = _this.aa3; });
                break;
            case "YAxisLabelLocation":
                this.agj();
                break;
            case "XAxisLabelLocation":
                this.age();
                break;
        }
    };
    XYChart.prototype.agj = function () {
        var a = this.aav(this.aaz);
        if (a == 2 || a == 7) {
            this.agq = 2;
        }
        else {
            this.agq = 0;
        }
        this.agi(function (b) { return b.location = a; });
    };
    XYChart.prototype.age = function () {
        var a = this.aau(this.aax);
        if (a == 1 || a == 5) {
            this.ahq = 0;
        }
        else {
            this.ahq = 2;
        }
        this.agd(function (b) { return b.location = a; });
    };
    XYChart.prototype.aav = function (a) {
        if (a == 0) {
            return 2;
        }
        else if (a == 1) {
            return 3;
        }
        else if (a == 3) {
            return 7;
        }
        else if (a == 2) {
            return 6;
        }
        else {
            if (this.cb == 1) {
                return 3;
            }
            else {
                return 2;
            }
        }
    };
    XYChart.prototype.aau = function (a) {
        if (a == 1) {
            return 1;
        }
        else if (a == 0) {
            return 0;
        }
        else if (a == 3) {
            return 5;
        }
        else if (a == 2) {
            return 4;
        }
        else {
            return 1;
        }
    };
    Object.defineProperty(XYChart.prototype, "ade", {
        get: function () {
            return this.adc;
        },
        set: function (a) {
            var b = this.ade;
            if (a != b) {
                this.adc = a;
                this.wd("XAxisLabel", b, this.ade);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "adf", {
        get: function () {
            return this.add;
        },
        set: function (a) {
            var b = this.adf;
            if (a != b) {
                this.add = a;
                this.wd("YAxisLabel", b, this.adf);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aha", {
        get: function () {
            return this.agu;
        },
        set: function (a) {
            var b = this.aha;
            if (a != b) {
                this.agu = a;
                this.wd("XAxisMajorStroke", b, this.aha);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ahh", {
        get: function () {
            return this.ag1;
        },
        set: function (a) {
            var b = this.ahh;
            if (a != b) {
                this.ag1 = a;
                this.wd("YAxisMajorStroke", b, this.ahh);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acg", {
        get: function () {
            return this.aba;
        },
        set: function (a) {
            var b = this.acg;
            if (a != b) {
                this.aba = a;
                this.wd("XAxisMajorStrokeThickness", b, this.acg);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acz", {
        get: function () {
            return this.abt;
        },
        set: function (a) {
            var b = this.acz;
            if (a != b) {
                this.abt = a;
                this.wd("YAxisMajorStrokeThickness", b, this.acz);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acj", {
        get: function () {
            return this.abd;
        },
        set: function (a) {
            var b = this.acj;
            if (a != b) {
                this.abd = a;
                this.wd("XAxisMinorStrokeThickness", b, this.acj);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ac2", {
        get: function () {
            return this.abw;
        },
        set: function (a) {
            var b = this.ac2;
            if (a != b) {
                this.abw = a;
                this.wd("YAxisMinorStrokeThickness", b, this.ac2);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ahc", {
        get: function () {
            return this.agw;
        },
        set: function (a) {
            var b = this.ahc;
            if (a != b) {
                this.agw = a;
                this.wd("XAxisStrip", b, this.ahc);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ahj", {
        get: function () {
            return this.ag3;
        },
        set: function (a) {
            var b = this.ahj;
            if (a != b) {
                this.ag3 = a;
                this.wd("YAxisStrip", b, this.ahj);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ahd", {
        get: function () {
            return this.agx;
        },
        set: function (a) {
            var b = this.ahd;
            if (a != b) {
                this.agx = a;
                this.wd("XAxisStroke", b, this.ahd);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ahk", {
        get: function () {
            return this.ag4;
        },
        set: function (a) {
            var b = this.ahk;
            if (a != b) {
                this.ag4 = a;
                this.wd("YAxisStroke", b, this.ahk);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ack", {
        get: function () {
            return this.abe;
        },
        set: function (a) {
            var b = this.ack;
            if (a != b) {
                this.abe = a;
                this.wd("XAxisStrokeThickness", b, this.ack);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ac3", {
        get: function () {
            return this.abx;
        },
        set: function (a) {
            var b = this.ac3;
            if (a != b) {
                this.abx = a;
                this.wd("YAxisStrokeThickness", b, this.ac3);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acl", {
        get: function () {
            return this.abf;
        },
        set: function (a) {
            var b = this.acl;
            if (a != b) {
                this.abf = a;
                this.wd("XAxisTickLength", b, this.acl);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ac4", {
        get: function () {
            return this.aby;
        },
        set: function (a) {
            var b = this.ac4;
            if (a != b) {
                this.aby = a;
                this.wd("YAxisTickLength", b, this.ac4);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ahe", {
        get: function () {
            return this.agy;
        },
        set: function (a) {
            var b = this.ahe;
            if (a != b) {
                this.agy = a;
                this.wd("XAxisTickStroke", b, this.ahe);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ahl", {
        get: function () {
            return this.ag5;
        },
        set: function (a) {
            var b = this.ahl;
            if (a != b) {
                this.ag5 = a;
                this.wd("YAxisTickStroke", b, this.ahl);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acm", {
        get: function () {
            return this.abg;
        },
        set: function (a) {
            var b = this.acm;
            if (a != b) {
                this.abg = a;
                this.wd("XAxisTickStrokeThickness", b, this.acm);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ac5", {
        get: function () {
            return this.abz;
        },
        set: function (a) {
            var b = this.ac5;
            if (a != b) {
                this.abz = a;
                this.wd("YAxisTickStrokeThickness", b, this.ac5);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aem", {
        get: function () {
            return this.adi;
        },
        set: function (a) {
            var b = this.aem;
            if (a != b) {
                this.adi = a;
                this.wd("XAxisTitle", b, this.aem);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aft", {
        get: function () {
            return this.adm;
        },
        set: function (a) {
            var b = this.aft;
            if (a != b) {
                this.adm = a;
                this.wd("YAxisTitle", b, this.aft);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ahb", {
        get: function () {
            return this.agv;
        },
        set: function (a) {
            var b = this.ahb;
            if (a != b) {
                this.agv = a;
                this.wd("XAxisMinorStroke", b, this.ahb);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ahi", {
        get: function () {
            return this.ag2;
        },
        set: function (a) {
            var b = this.ahi;
            if (a != b) {
                this.ag2 = a;
                this.wd("YAxisMinorStroke", b, this.ahi);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acb", {
        get: function () {
            return this.aa5;
        },
        set: function (a) {
            var b = this.acb;
            if (a != b) {
                this.aa5 = a;
                this.wd("XAxisLabelAngle", b, this.acb);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acu", {
        get: function () {
            return this.abo;
        },
        set: function (a) {
            var b = this.acu;
            if (a != b) {
                this.abo = a;
                this.wd("YAxisLabelAngle", b, this.acu);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aca", {
        get: function () {
            return this.aa4;
        },
        set: function (a) {
            var b = this.aca;
            if (a != b) {
                this.aa4 = a;
                this.wd("XAxisExtent", b, this.aca);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "act", {
        get: function () {
            return this.abn;
        },
        set: function (a) {
            var b = this.act;
            if (a != b) {
                this.abn = a;
                this.wd("YAxisExtent", b, this.act);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ach", {
        get: function () {
            return this.abb;
        },
        set: function (a) {
            var b = this.ach;
            if (a != b) {
                this.abb = a;
                this.wd("XAxisMaximumExtent", b, this.ach);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ac0", {
        get: function () {
            return this.abu;
        },
        set: function (a) {
            var b = this.ac0;
            if (a != b) {
                this.abu = a;
                this.wd("YAxisMaximumExtent", b, this.ac0);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aci", {
        get: function () {
            return this.abc;
        },
        set: function (a) {
            var b = this.aci;
            if (a != b) {
                this.abc = a;
                this.wd("XAxisMaximumExtentPercentage", b, this.aci);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ac1", {
        get: function () {
            return this.abv;
        },
        set: function (a) {
            var b = this.ac1;
            if (a != b) {
                this.abv = a;
                this.wd("YAxisMaximumExtentPercentage", b, this.ac1);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acn", {
        get: function () {
            return this.abh;
        },
        set: function (a) {
            var b = this.acn;
            if (a != b) {
                this.abh = a;
                this.wd("XAxisTitleAngle", b, this.acn);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ac6", {
        get: function () {
            return this.ab0;
        },
        set: function (a) {
            var b = this.ac6;
            if (a != b) {
                this.ab0 = a;
                this.wd("YAxisTitleAngle", b, this.ac6);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aa2", {
        get: function () {
            return this.aa0;
        },
        set: function (a) {
            var b = this.aa2;
            if (a != b) {
                this.aa0 = a;
                this.wd("XAxisInverted", b, this.aa2);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aa3", {
        get: function () {
            return this.aa1;
        },
        set: function (a) {
            var b = this.aa3;
            if (a != b) {
                this.aa1 = a;
                this.wd("YAxisInverted", b, this.aa3);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "agp", {
        get: function () {
            return this.agm;
        },
        set: function (a) {
            var b = this.agp;
            if (a != b) {
                this.agm = a;
                this.wd("XAxisTitleAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.agp));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ahs", {
        get: function () {
            return this.ahp;
        },
        set: function (a) {
            var b = this.ahs;
            if (a != b) {
                this.ahp = a;
                this.wd("YAxisTitleAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.ahs));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ago", {
        get: function () {
            return this.agl;
        },
        set: function (a) {
            var b = this.ago;
            if (a != b) {
                this.agl = a;
                this.wd("XAxisLabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.ago));
            }
        },
        enumerable: false,
        configurable: true
    });
    XYChart.prototype.get_agq = function () {
        return this.agn;
    };
    XYChart.prototype.set_agq = function (a) {
        var b = this.agq;
        if (a != b) {
            this.agn = a;
            this.wd("YAxisLabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.agq));
        }
    };
    Object.defineProperty(XYChart.prototype, "agq", {
        get: function () {
            return this.get_agq();
        },
        set: function (a) {
            this.set_agq(a);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ahq", {
        get: function () {
            return this.ahn;
        },
        set: function (a) {
            var b = this.ahq;
            if (a != b) {
                this.ahn = a;
                this.wd("XAxisLabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.ahq));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ahr", {
        get: function () {
            return this.aho;
        },
        set: function (a) {
            var b = this.ahr;
            if (a != b) {
                this.aho = a;
                this.wd("YAxisLabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.ahr));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ahv", {
        get: function () {
            return this.aht;
        },
        set: function (a) {
            var b = this.ahv;
            if (a != b) {
                this.aht = a;
                this.wd("XAxisLabelVisibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.ahv));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ahw", {
        get: function () {
            return this.ahu;
        },
        set: function (a) {
            var b = this.ahw;
            if (a != b) {
                this.ahu = a;
                this.wd("YAxisLabelVisibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.ahw));
            }
        },
        enumerable: false,
        configurable: true
    });
    XYChart.prototype.get_aaz = function () {
        return this.aay;
    };
    XYChart.prototype.set_aaz = function (a) {
        var b = this.aaz;
        if (a != b) {
            this.aay = a;
            this.wd("YAxisLabelLocation", enumGetBox(YAxisLabelLocation_$type, b), enumGetBox(YAxisLabelLocation_$type, this.aaz));
        }
    };
    Object.defineProperty(XYChart.prototype, "aaz", {
        get: function () {
            return this.get_aaz();
        },
        set: function (a) {
            this.set_aaz(a);
        },
        enumerable: false,
        configurable: true
    });
    XYChart.prototype.get_aax = function () {
        return this.aaw;
    };
    XYChart.prototype.set_aax = function (a) {
        var b = this.aax;
        if (a != b) {
            this.aaw = a;
            this.wd("XAxisLabelLocation", enumGetBox(XAxisLabelLocation_$type, b), enumGetBox(XAxisLabelLocation_$type, this.aax));
        }
    };
    Object.defineProperty(XYChart.prototype, "aax", {
        get: function () {
            return this.get_aax();
        },
        set: function (a) {
            this.set_aax(a);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "adw", {
        get: function () {
            return this.adg;
        },
        set: function (a) {
            var b = this.adg;
            if (a != b) {
                this.adg = a;
                this.wd("XAxisLabelFormat", b, this.adg);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aam", {
        get: function () {
            return this.aak;
        },
        set: function (a) {
            var b = this.aak;
            if (a != b) {
                this.aak = a;
                this.wd("XAxisLabelFormatSpecifiers", b, this.aak);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ae3", {
        get: function () {
            return this.adk;
        },
        set: function (a) {
            var b = this.adk;
            if (a != b) {
                this.adk = a;
                this.wd("YAxisLabelFormat", b, this.adk);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aan", {
        get: function () {
            return this.aal;
        },
        set: function (a) {
            var b = this.aal;
            if (a != b) {
                this.aal = a;
                this.wd("YAxisLabelFormatSpecifiers", b, this.aal);
            }
        },
        enumerable: false,
        configurable: true
    });
    XYChart.$t = markType(XYChart, 'XYChart', DomainChart.$);
    return XYChart;
}(DomainChart));
export { XYChart };
