import { XYChart } from "./XYChart";
import { IEnumerable, Type } from "igniteui-angular-core";
import { DomainType } from "./DomainType";
import { CategoryChartType } from "./CategoryChartType";
import { CategorySeriesMarkerCollisionAvoidance } from "./CategorySeriesMarkerCollisionAvoidance";
import { CategoryTransitionInMode } from "./CategoryTransitionInMode";
import { TransitionInSpeedType } from "./TransitionInSpeedType";
import { AutoMarginsAndAngleUpdateMode } from "./AutoMarginsAndAngleUpdateMode";
import { AxisRangeBufferMode } from "./AxisRangeBufferMode";
import { BrushCollection } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { DataSeriesType } from "igniteui-angular-core";
import { IDataSeriesAdapterRule } from "igniteui-angular-core";
import { Series } from "./Series";
import { XamDataChart } from "./XamDataChart";
import { Axis } from "./Axis";
import { MarkerType } from "./MarkerType";
import { DataSeries } from "igniteui-angular-core";
import { ComputedPlotAreaMarginMode } from "./ComputedPlotAreaMarginMode";
/**
 * @hidden
 */
export declare class CategoryChart extends XYChart {
    static $t: Type;
    protected vm(): void;
    protected vo(a: Series, b: number): void;
    protected wh(a: string, b: any, c: any): void;
    private aki;
    get akl(): number;
    set akl(a: number);
    private akj;
    get akm(): number;
    set akm(a: number);
    private ail;
    get ain(): (time: number) => number;
    set ain(a: (time: number) => number);
    private aim;
    get aio(): (time: number) => number;
    set aio(a: (time: number) => number);
    aks(): string;
    protected vh(a: XamDataChart, b: any): void;
    protected vn(a: Series, b: number): void;
    private aib;
    private aif;
    protected ux(): void;
    protected af9(a: Axis): void;
    protected af7(a: Axis): void;
    protected get_cb(): DomainType;
    get cb(): DomainType;
    private ah5;
    get ah6(): CategoryChartType;
    set ah6(a: CategoryChartType);
    private ah7;
    get ah8(): CategorySeriesMarkerCollisionAvoidance;
    set ah8(a: CategorySeriesMarkerCollisionAvoidance);
    private air;
    get ai2(): boolean;
    set ai2(a: boolean);
    private ais;
    get ai3(): boolean;
    set ai3(a: boolean);
    private ah9;
    get aia(): CategoryTransitionInMode;
    set aia(a: CategoryTransitionInMode);
    private aij;
    get aik(): TransitionInSpeedType;
    set aik(a: TransitionInSpeedType);
    private ajf;
    get aj2(): number;
    set aj2(a: number);
    private aji;
    get aj5(): number;
    set aj5(a: number);
    private aje;
    get aj1(): number;
    set aj1(a: number);
    private ajh;
    get aj4(): number;
    set aj4(a: number);
    private ajg;
    get aj3(): number;
    set aj3(a: number);
    private ajj;
    get aj6(): number;
    set aj6(a: number);
    private ajp;
    get ake(): number;
    set ake(a: number);
    private ah1;
    get ah2(): AutoMarginsAndAngleUpdateMode;
    set ah2(a: AutoMarginsAndAngleUpdateMode);
    private ait;
    aly(): void;
    get ai4(): boolean;
    set ai4(a: boolean);
    protected static readonly ak1: string;
    private aiu;
    get ai5(): boolean;
    set ai5(a: boolean);
    private ajc;
    get ajt(): number;
    set ajt(a: number);
    private ajd;
    get aju(): number;
    set aju(a: number);
    private aiy;
    get ai9(): boolean;
    set ai9(a: boolean);
    private static readonly ak8;
    private aiv;
    get ai6(): boolean;
    set ai6(a: boolean);
    private static readonly alm;
    private aix;
    get ai8(): boolean;
    set ai8(a: boolean);
    private ah3;
    get ah4(): AxisRangeBufferMode;
    set ah4(a: AxisRangeBufferMode);
    private aiz;
    get aja(): boolean;
    set aja(a: boolean);
    private akk;
    get akn(): number;
    set akn(a: number);
    private ajr;
    get akg(): number;
    set akg(a: number);
    private ajq;
    get akf(): number;
    set akf(a: number);
    private ajs;
    get akh(): number;
    set akh(a: number);
    get aj0(): number;
    get ajz(): number;
    ajw(): number;
    ajy(): number;
    ajv(): number;
    ajx(): number;
    get akd(): number;
    get akc(): number;
    private ahx;
    get ahz(): BrushCollection;
    set ahz(a: BrushCollection);
    private ahy;
    get ah0(): BrushCollection;
    set ah0(a: BrushCollection);
    private aiw;
    get ai7(): boolean;
    set ai7(a: boolean);
    private ajk;
    get aj7(): number;
    set aj7(a: number);
    private ajl;
    get aj8(): number;
    set aj8(a: number);
    private ajm;
    get aj9(): number;
    set aj9(a: number);
    private ajn;
    get aka(): number;
    set aka(a: number);
    private ajo;
    get akb(): number;
    set akb(a: number);
    private aip;
    get ai0(): boolean;
    set ai0(a: boolean);
    private aiq;
    get ai1(): boolean;
    set ai1(a: boolean);
    constructor();
    protected get_h2(): List$1<DataSeriesType>;
    protected get h2(): List$1<DataSeriesType>;
    private ajb;
    protected h8(): IEnumerable;
    protected c1(a: Series): MarkerType;
    protected c3(a: Series): MarkerType;
    protected get_hk(): boolean;
    private alw;
    private alx;
    protected xa(): void;
    private _xAxis;
    private get xAxis();
    private set xAxis(value);
    private _yAxis;
    private get yAxis();
    private set yAxis(value);
    private aie;
    private aid;
    protected be(a: DataSeries): DataSeriesType;
    protected dc(a: DataSeries, b: DataSeriesType): Series;
    protected w8(a: DataSeries): void;
    protected xb(): void;
    protected get_h1(): List$1<IDataSeriesAdapterRule>;
    protected get h1(): List$1<IDataSeriesAdapterRule>;
    protected ur(a: Series, b: number): void;
    private alu;
    private alv;
    protected aao(): Axis;
    protected aap(): Axis;
    private aih;
    private aii;
    protected hy(a: string, b: boolean): List$1<Series>;
    protected ba(): ComputedPlotAreaMarginMode;
    protected xf(a: Series, b: Series, c: DataSeries): void;
    protected g4(): boolean;
    protected get_hb(): boolean;
    protected wd(a: string, b: any, c: any): void;
}
