import { Type } from "igniteui-angular-core";
import { ToolCommandStateChanged } from "igniteui-angular-core";
import { ToolActionInfo } from "igniteui-angular-core";
import { IDomainChartLike } from "./IDomainChartLike";
import { HashSet$1 } from "igniteui-angular-core";
import { IToolbarContextAccessor } from "igniteui-angular-core";
import { ToolCommandExecutionState } from "igniteui-angular-core";
import { ToolCommand } from "igniteui-angular-core";
/**
 * @hidden
 */
export interface IDomainChartToolbarProvider {
    container: any;
    commandChanged: (arg1: ToolCommandStateChanged) => void;
    getDesiredToolbarActions(a: IDomainChartLike, b: ToolActionInfo[], c: HashSet$1<IToolbarContextAccessor>): ToolActionInfo[];
    onToolCommandExecuting(a: IDomainChartLike, b: ToolCommand): ToolCommandExecutionState;
    onTargetPropertyChanged(a: IDomainChartLike, b: string, c: any, d: any): void;
}
/**
 * @hidden
 */
export declare let IDomainChartToolbarProvider_$type: Type;
