import { ShapeSeriesBase } from "./ShapeSeriesBase";
import { StyleSelector } from "./StyleSelector";
import { Style } from "igniteui-angular-core";
import { Series } from "./Series";
import { Type, Point } from "igniteui-angular-core";
import { SeriesView } from "./SeriesView";
import { ShapeSeriesViewBase } from "./ShapeSeriesViewBase";
import { DataContext } from "igniteui-angular-core";
import { FrameworkElement } from "igniteui-angular-core";
import { ChartSelection } from "./ChartSelection";
import { Rect } from "igniteui-angular-core";
import { SeriesSelectionBehavior } from "./SeriesSelectionBehavior";
import { List$1 } from "igniteui-angular-core";
import { PathGeometry } from "igniteui-angular-core";
import { PointCollection } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare class ScatterPolylineSeries extends ShapeSeriesBase {
    static $t: Type;
    protected bk(): Series;
    protected get_fs(): boolean;
    constructor();
    protected ct(): SeriesView;
    protected get_x5(): boolean;
    q3(a: SeriesView): void;
    protected aac: ScatterPolylineSeriesView;
    protected get_yb(): boolean;
    aad: StyleSelector;
    aai: Style;
    protected rc(a: any, b: string, c: any, d: any): void;
    protected zs(a: SeriesView): void;
    a2(a: Point, b: boolean): DataContext;
    ak(a: Rect, b: SeriesSelectionBehavior): ChartSelection[];
    p6(a: Rect, b: List$1<ChartSelection>, c: SeriesSelectionBehavior): void;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class ScatterPolylineSeriesView extends ShapeSeriesViewBase {
    static $t: Type;
    constructor(a: ScatterPolylineSeries);
    a4(): void;
    protected di(a: number, b: List$1<PointCollection>): PathGeometry;
    cz(a: FrameworkElement, b: any, c: boolean): void;
    protected cx(a: FrameworkElement, b: PathGeometry): void;
    protected ak(a: number): any;
    protected aj(a: number): any;
    co(a: Rect): boolean;
    getDefaultTooltipTemplate(): string;
}
